;/*
;    ###########################################################################
; 
;    "ATU version 1.0 (SPIN ATU)" - Copyright (C) 1996, Tibor Csoka (6505167273)
;
;
;    Software author, contact: csoka.tibor@gmail.com
;
;    ***************************************************************************
;     *                                                                       *
;     *   "ATU version 1.0 (SPIN ATU)" circuits diagram is available in pdf   *
;     *    Complete, revised, and edited pdf reference manuals are also       *
;     *    available.                                                         *
;     *                                                                       *
;     *                                                                       *
;     *             >>> See http://www.fanit.sk for details. <<<              *
;     *                                                                       *
;     *           Thank you for using "ATU version 1.0 (SPIN ATU)",           *
;     *                    and thank you for your support !                   *
;     *                                                                       *
;    ***************************************************************************
;
;
;    This file is part of the "ATU version 1.0 (SPIN ATU)" distribution.
;
;    "ATU version 1.0 (SPIN ATU)" is free software; you can redistribute it 
;    and/or modify it under the terms of the: 
;
;                "GNU General Public License (version 2)"
;    
;    as published by the Free Software Foundation AND MODIFIED BY the: 
;                 
;                 "ATU version 1.0 (SPIN ATU)" exception.
;
;    >>>NOTE<<< 
;    
;    "ATU version 1.0 (SPIN ATU)" is distributed in the hope that it will be
;    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;    Public License for more details. You should have received a copy of the
;    GNU General Public License and the "ATU version 1.0 (SPIN ATU)" license
;    exception along with "ATU version 1.0 (SPIN ATU)" if not, it can be viewed
;    here: http://www.fanit.sk.
;
;    1 tab == 4 spaces!
;
;    ###########################################################################
;*/
;
;------------------------------------------------------------------------
;
;PROGRAM RETRANSLATORA PRE SYSTEM =SPIN ATU=
;------------------------------------------------------------------------
;1) ADRESA 0000H ROM 27C256, KANALY SU TESTOVANE :
;   - cca. 0.240 s min. JEDEN KANAL (1.68 s VSETKY), 150 BIT/sekunda
;   - cca. 0.400 s max. JEDEN KANAL (2.80 s VSETKY), 150 BIT/sekunda
;
;Maximalny cas vykonavania jednej slucky v 'MAIN' moze byt 130 ms !)
;PRENOSOVE PARAMETRE SU (148.73 - 153,11) BIT/sekunda
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Autor : Ing. Tibor CSOKA, BRATISLAVA - SLOVENSKO, marec 1996.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TRUE      EQU     0FFH
FALSE     EQU     00H
;
SETCRC    EQU     TRUE            ;NASTAV AKTIVNY 'CRC' PROTOKOL V 'SW' SYSTEMU
;
DPLR      EQU     82H             ;DOLNY BYTE REGISTRA DPTR
DPHR      EQU     83H             ;HORNY BYTE REGISTRA DPTR
PCON      EQU     87H             ;ADRESA REGISTRA RIADENIA NAPAJANIA
R00       EQU     00H             ;R0 BANKA 0
R01       EQU     01H             ;R1 POMOCNE POCITADLO ADRIES (STATx,...)
LONGBU    EQU     02H             ;DLZKA SPRAVY VYSIELANEJ Z 'PC'
LONRET    EQU     03H             ;DLZKA SPRAVY VYSIELANEJ Z 'RET'
BCC       EQU     04H             ;KONTROLNY SUCET PRE SPRAVY Z 'PC' A 'RET'
INTTIM    EQU     05H             ;POCITADLO POCTU POLPERIOD 18 KHz (PRERUSENI)
STAV      EQU     06H             ;AKTIVNY STAV 'TAMPER' + 'POZIADAVKA NA PRIRADENIE'
POM1      EQU     07H             ;POMOCNY REGISTER 1
POM2      EQU     08H             ;POMOCNY REGISTER 2
POM3      EQU     09H             ;POMOCNY REGISTER 3
PTIM1     EQU     0AH             ;POMOCNE POCITADLO CASU
PTIM2     EQU     0BH             ;POMOCNE POCITADLO CASU
MAXREP    EQU     0CH             ;POMOCNE POCITADLO CASU
ERRORX    EQU     0DH             ;PRIZNAK SPRAVNOSTI PRIMU BYTU Z 'OBJEKTU'
PUT1      EQU     0EH             ;POMOCNY REG. PRI VKLADANI DO VYSIELACIEHO BUFFRA
PUT2      EQU     0FH             ;POMOCNY REG. PRI VKLADANI DO VYSIELACIEHO BUFFRA
HDBYTE    EQU     10H             ;REGISTER PRE ULOZENIE BYTU VYSIELANEHO DO 'KZ'
EROR18    EQU     11H             ;PRIZNAK, ZE PRI VYSIELANI BYTU DO 'KZ' NEBOLA CHYBA
POBJ1     EQU     12H             ;POMOCNY REGISTER
POBJ2     EQU     13H             ;POMOCNY REGISTER
POBJ3     EQU     14H             ;POMOCNY REGISTER
MWORK1    EQU     15H             ;POMOCNY REGISTER
MWORK2    EQU     16H             ;POMOCNY REGISTER
RXKZER    EQU     17H             ;PRIZNAK CHYBNEHO PRIJMU BYTU Z 'KZ'
RXDATA    EQU     18H             ;REGISTER UCHOVAVA PRIJATY BYTE Z 'KZ'
TIMRX     EQU     19H             ;POCITADLO CASU PRE PRIJEM BYTU Z 'KZ'
POML      EQU     1AH             ;POMOCNY BYTE PRE UCHOVANIE ADRESY KZ PRE 'CRC'
POMH      EQU     1BH             ;POMOCNY BYTE PRE UCHOVANIE ADRESY KZ PRE 'CRC'
ADCRCL    EQU     1CH             ;POMOCNY BYTE PRE UCHOVANIE ADRESY KZ PRE 'CRC'
ADCRCH    EQU     1DH             ;POMOCNY BYTE PRE UCHOVANIE ADRESY KZ PRE 'CRC'
ERCRC     EQU     1EH             ;POCITADLO POCTU CHYBNYCH VYSIELANI PRI 'CRC'
GENCRC    EQU     1FH             ;KVAZI-NAHODNY GENERATOR MODULACNEHO POLYNOMU 'CRC'
SYSFLG    EQU     20H             ;REZERVOVANE PRE SYSTEMOVE PRIZNAKY
CYCLES    EQU     21H             ;POCITADLO VYMEN PROTOKOLU 'CRC'
CRREAD    EQU     22H             ;POMOCNE POISTNE POCITADLO max. POCTU CITANIA 'KZ' PO 'CRC'
ATSFLG    EQU     28H             ;PRIZNAKY PRE RIADENIE CINNOSTI 'ATU'
;
ADPRIR    EQU     0000H           ;POCIATOCNA ADRESA PRIZNAKOV PRIRADENOSTI
RETBUF    EQU     0200H           ;POCIATOCNA ADRESA PRIJIMACIEHO BUFFRA UDAJOV Z 'RET'
PCBUF     EQU     0400H           ;POCIATOCNA ADRESA PRIJIMACIEHO BUFFRA UDAJOV Z 'PC'
ADSTAT    EQU     0600H           ;POCIATOCNA ADRESA PRIZNAKOV STAVU OBJEKTU (KZ)
ADDOPL    EQU     0800H           ;POCIATOCNA ADRESA DOPLNKOVYCH PRIZNAKOV PRE 'KZ'
ADCRC     EQU     0A00H           ;ADRESA 512 POLYNOMOV 'CRC' PRE JEDNOTLIVE 'KZ'
ADSEC     EQU     0C00H           ;ADRESA 512 PRIZNAKOV AKTIVNEHO REZIMU 'HIGH SECURITY'
ADBIT     EQU     0E00H           ;ADRESA PRIZNAKOV PRE REZIM 'HIGH SECURITY'
ADRLED    EQU    0FFFFH           ;ADRESA 'RWM' LED DIOD
;
PCYES     EQU     25H             ;KONSTANTA - ODPOVED NA AKTIVNY 'MUX' Z IBM PC
PCACK     EQU     27H             ;POTVRDENIE PRE 'PC' A Z 'PC'
PCNAK     EQU     29H             ;POTVRDENIE PRE 'PC' A Z 'PC'
ACK	  EQU     06H		  ;UDAJ PRE RIADENIE SER. LINKY RETRANSLATORA
NAK	  EQU	  15H		  ;UDAJ PRE RIADENIE SER. LINKY RETRANSLATORA
GETST     EQU     0B5H            ;POVEL Z 'MUX' NA ODOVZDANIE STAVU RETRANSLATORA
MUXACK    EQU     0C6H            ;POTVRDENIE Z 'MUX' DO 'RET'
MUXNAK    EQU     0D7H            ;CHYBA POTVRDENIA Z 'MUX' DO 'RET'
REACK     EQU     0EAH            ;POTVRDENIE Z 'RET' ZE PRIJIMACI BUFFER JE PRAZDNY
RENAK     EQU     0ECH            ;POTVRDENIE Z 'RET' ZE PRIJIMACI BUFFER JE PLNY
MAXCYC    EQU     35              ;MINIMALNY POCET TESTOV 'KZ' MEDZI 2-mi VYMENAMI 'CRC'
SYNCYC    EQU     5               ;CAS NA SYNCHRONIZACIU 'CRC' (POCET CYKLOV TESTOV 'KZ')
PCHYB     EQU     256-5           ;DOPLNOK K 256 (? x CHYBNY PRENOS 'CRC' TESTUJE)
MAXTX     EQU     107             ;MAX. DLZKA VYSIELACIEHO BUFFRA - 2 BYTY (148 BYTOV => MAX.=150 )
MAXTXR    EQU     109             ;MAX. DLZKA VYS. BUFFRA - 2 (tj. 148 BYTOV JA MAX. ROZSAH REZERVY)
;SYSTEMOVE PRIZNAKY (RWM INTERNA 20H)
EN18      EQU     20H.0           ;PRIZNAKOVY BIT PRE POVOLENIE CINNOSTI GEN. 18 KHz
MUXOK     EQU     20H.1           ;PRIZNAK NADVIAZANIA KOMUNIKACIE S 'MULTIPLEXEROM'
AKTPRT    EQU     20H.2           ;PRIZNAK ZE JE AKTIVNY PODPROGRAM KOMUNIKACNEHO PROTOKOLU
TBIT      EQU     20H.3           ;POMOCNY BIT
AKTOBJ    EQU     20H.4           ;PRIZNAK AKTIVNEHO PODPROGRAMU 'OBJEKT'
NOINCR    EQU     20H.5           ;PRIZNAK POZIADAVKY NA 'NEZMENENIE ADRESY KZ' V HLAVNEJ SLUCKE
RESATU    EQU     20H.6           ;POZIADAVKA NA 'SW' RESET 'ATU'
ISCRC     EQU     20H.7           ;POZIADAVKA NA 'HIGH SECURITY' PROTOKOL
;SYSTEMOVE PRIZNAKY PRE RIADENIE 'ATU'
ATSBUF    EQU     28H.0           ;PREPINAC MEDZI VYSIELANIM STAVU A BUFFRA
ATSTX     EQU     28H.1           ;PRIZNAK VNUTENEHO VYSLANIA STAVU 'ATS' DO 'PC'
CYC512    EQU     28H.2           ;PRIZNAK OTESTOVANIA 512 ADRIES 'KZ'
AKTCRC    EQU     28H.3           ;PRIZNAK AKTIVITY 'CRC' PROTOKOLU V 'SW'
FULTXL    EQU     28H.4           ;PRIZNAK PLNOSTI VYSIELACIEHO BUFFRA (MAX-2)
FULTXH    EQU     28H.5           ;PRIZNAK PLNOSTI VYSIELACIEHO BUFFRA (MAX)
TSTCRC    EQU     28H.6           ;PRIZNAK TESTOVANIA 'CRC' AK JE 'MUX' SPOJENIE 'OK !'
;PRIZNAKY STAVOVEHO BYTU PRE KAZDE 'KZ' (512 BYTOV OD ADRESY ADSTAT)
BNEZR     EQU     4               ;PRIZNAKOVY BIT 'NEZROZUMITELNOST DAT'  V STAVOVOM REGISTRI 'KZ'
BDOTAZ    EQU     5               ;PRIZNAKOVY BIT 'DOTAZ' V STAVOVOM REGISTRI 'KZ'
BKZER     EQU     6               ;PRIZNAKOVY BIT 'PORUCHA KZ' V STAVOVOM REGISTRI
BSPOJ     EQU     7               ;PRIZNAKOVY BIT 'SPOJ ' V STAVOVOM REGISTRI 'KZ'
;PRIZNAKOVY BYTE PRE 'CRC' (512 BYTOV OD ADRESY ADBIT) PRE KAZDE 'KZ'
BRCRC     EQU     0               ;POZIADAVKA NA NASTAVENIE 'CRC' DO '80H'
BGCRC     EQU     1               ;POZIADAVKA NA VYSLANIE AKTUALNEHO 'CRC' DO 'ATU'
BPOC1     EQU     2               ;BIT POCITADLA POCTU CYKLOV CAKANIA NA ODPOVED 'CRC' Z 'KZ'
BPOC2     EQU     3               ;BIT POCITADLA POCTU CYKLOV CAKANIA NA ODPOVED 'CRC' Z 'KZ'
BSPEC     EQU     4               ;SPECIALNY PRIZNAK - POZIADAVKA NA VYNECHANIE CYKLU 'CRC'
BMCRC     EQU     5               ;PRIZNAK CAKANIA NA ODPOVED MODULACIE 'CRC'
BWCRC     EQU     6               ;PRIZNAK CAKANIA NA AKTUALNY OBSAH 'CRC'
BECRC     EQU     7               ;PRIZNAK CHYBY V 'CRC' PROTOKOLE
;
PA0       EQU     P1.0            ;A0 ADRESA PRE OBJEKT
PA1       EQU     P1.1            ;A1 ADRESA PRE OBJEKT
PA2       EQU     P1.2            ;A2 ADRESA PRE OBJEKT
PA3       EQU     P1.3            ;A3 ADRESA PRE OBJEKT
PA4       EQU     P1.4            ;A4 ADRESA PRE OBJEKT
PA5       EQU     P1.5            ;A5 ADRESA PRE OBJEKT
PA6       EQU     P1.6            ;A6 ADRESA PRE OBJEKT
PA7       EQU     P1.7            ;A7 ADRESA PRE OBJEKT
RX        EQU     P3.0            ;SERIOVA LINKA - PRIJIMAC
TX        EQU     P3.1            ;SERIOVA LINKA - VYSIELAC
R18       EQU     P3.2            ;PRIJIMAC 18 KHz
T18       EQU     P3.3            ;VYSIELAC 18 KHz
TAM       EQU     P3.4            ;TAMPER ATS MODULU
PA8       EQU     P3.5            ;A8 ADRESA PRE OBJEKT
;
MAGIC     EQU     3274H           ;KONTROLNA SUMA PRE 'LOGO' - ADRESY (0020 - 009F) v ROM
ATTACH    EQU     03H             ;MASKA PRE TESTOVANIE NAJNIZSICH 2. BITOV PRI PRIRADENI 'KZ'
REPMAX    EQU     16              ;MAX. POCET OPAKOVANI JEDNEHO 'KZ' ZA SEBOU
OBJMAX    EQU     REPMAX-2        ;MAX. POCET TESTOVANI PULZOV NA LINKE (MENEJ AKO REPMAX TESTOV !!!)
RESKZ     EQU     50H             ;KASHTAN - POVEL Z 'PCO' PRE SW RESET 'KZ'
CHYCRC    EQU     62H             ;KASHTAN - 'DATA NEZROZUMITELNE', VYSIELA PRI CHYBNOM 'CRC'
TAMOK     EQU     0AAH            ;KASHTAN - 'TAMPER OK'
TAMER     EQU     0ABH            ;KASHTAN - 'TAMPER ERROR'
PTAMOK    EQU     0BAH            ;KASHTAN - 'PRIRAD KZ' + 'TAMPER OK'
PTAMER    EQU     0BBH            ;KASHTAN - 'PRIRAD KZ' + 'TAMPER ERROR'
UNLOST    EQU     60H             ;KASHTAN - 'OBNOVENIE SPOJENIA S KZ'
LOST      EQU     61H             ;KASHTAN - 'STRATA SPOJENIA S KZ'
NOVALI    EQU     62H             ;KASHTAN - 'DATA Z KZ SU NEZROZUMITELNE;
KZERR     EQU     63H             ;KASHTAN - 'PORUCHA KZ - STALE 18 KHz NA LINKE'
KZPRIR    EQU     64H             ;KASHTAN - 'PRIJATIE PRIRADENIA KZ'
KZODRA    EQU     65H             ;KASHTAN - 'PRIJATIE ODRADENIA KZ'
REZ1      EQU     66H             ;KASHTAN - 'KZ NEPREVZALO POVEL'
REZ2      EQU     67H             ;KASHTAN - 'KZ PREVZALO POVEL'
KZERPO    EQU     6FH             ;KASHTAN - 'CHYBA PRIRADENIA/ODRADENIA KZ'
RCRC      EQU     7DH             ;SPIN - POVEL PRE NASTAVENIE 'CRC' NA 'KZ' DO "80H"
GCRC      EQU     7EH             ;SPIN - VYZVA DO 'KZ' NA VYSLANIE AKTUALNEHO 'CRC' DO 'ATU'
RESATS    EQU     5AH             ;POVEL PRE 'SW' RESET RETRANSLATORA
PRIRAD    EQU     10H             ;POVEL NA PRIRADENIE OBJEKTU
ODRAD     EQU     20H             ;POVEL NA ODRADENIE OBJEKTU
DOTAZ     EQU     30H             ;POVEL NA DOTAZ STAVU OBJEKTU
KVIT      EQU     40H             ;POVEL NA ZAPNUTIE 'LED KVIT' NA OBJEKTE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ORG     0000H
STRT:   LJMP    RESTA           ;SKOK NA ZACIATOK HL.PROGRAMU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PRERUSENIE 'CASOVACA 0' - GENERUJE 18 KHz, POCITA POLPERIODY (2 BYTY ZASOBNIKA)
        ORG     000BH           ;PRERUSENIE CASOVACA T0 - KAZDYCH 28 us
INTT0:  JNB     EN18,NO18       ;TEST CI JE POVOLENE GENEROVANIE 18 KHz
        CPL     T18
NO18:   INC     INTTIM          ;POCITADLO POLPERIOD 18 KHz
        RETI
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ORG     0020H
ADLOGO: DB      '################'
        DB      '#(C) T.CSOKA   #'
        DB      '#atu0000-v96/01#'
        DB      '################'
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TESTS:  NOP                     ;INICIALIZACNE TESTY
        MOV     P1,#0FFH        ;NASTAVENIE PORTU P1
        MOV     P3,#0FFH        ;NASTAVENIE PORTU P3
        LJMP    NEWTST
HALT1:  MOV     DPTR,#ADRLED    ;ZAPNI VSETKYCH 8 LED DIOD PRI CHYBE
        MOV     A,#00H
        MOVX    @DPTR,A
        LJMP    HALT1           ;OSTANE STAT PRI CHYBE !
NEWTST: MOV     DPTR,#ADRLED    ;ZAPNI 0,2,4,6 LED DIODU PRI TESTE uP
        MOV     A,#055H
        MOVX    @DPTR,A
        MOV     A,#55H          ;TEST ACC
        CJNE    A,#55H,HALT1
        MOV     A,#0AAH
        CJNE    A,#0AAH,HALT1
        MOV     B,#55H          ;TEST 'B'
        MOV     A,B
        CJNE    A,#55H,HALT1
        MOV     B,#0AAH
        MOV     A,B
        CJNE    A,#0AAH,HALT1
        MOV     A,#00H
        MOV     R0,#55H         ;TEST R0
        MOV     A,R0
        CJNE    A,#55H,HALT1
        MOV     R0,#0AAH
        MOV     A,R0
        CJNE    A,#0AAH,HALT1
        MOV     R0,#7FH         ;TEST 128 BYTOV RWM INTERNEJ + VYNULUJ RWM
TST128: MOV     @R0,#55H
        MOV     A,@R0
        CJNE    A,#55H,HALT1
        MOV     @R0,#0AAH
        MOV     A,@R0
        CJNE    A,#0AAH,HALT1
        MOV     @R0,#00H
        MOV     A,@R0
        CJNE    A,#00H,HALT1
        DJNZ    R0,TST128
;
        MOV     DPTR,#ADRLED    ;ZAPNI 1,3,5,7 LED DIODU PRI TESTE 'RWM'
        MOV     A,#0AAH
        MOVX    @DPTR,A
        MOV     DPTR,#0000H     ;TEST EXTERNEJ RWM 32 KBYTE + VYNULOVANIE PAMATE
TOCRWM: MOV     A,#0AAH
        MOVX    @DPTR,A
        MOV     A,#00H
        MOVX    A,@DPTR
        CJNE    A,#0AAH,HALT1
        MOV     A,#055H
        MOVX    @DPTR,A
        MOV     A,#00H
        MOVX    A,@DPTR
        CJNE    A,#055H,HALT1
        MOV     A,#00H
        MOVX    @DPTR,A
        MOV     A,#0FFH
        MOVX    A,@DPTR
        CJNE    A,#00H,HALT1
        INC     DPTR
        ANL     DPHR,#7FH       ;'F' BIT JE STALE = 0 !!! (CE' RWM)
        MOV     A,DPLR          ;TEST CI SU OTESTOVANE VSETKY BYTY EXTERNEJ RWM
        ORL     A,DPHR
        JNZ     TOCRWM
;
        MOV     DPTR,#ADRLED
        MOV     A,#099H         ;ZAPNE LED 1,2,4,5 PRE TEST 'ROM'
        MOVX    @DPTR,A
ERLOGO: MOV     DPTR,#ADLOGO    ;TEST 'LOGO' AUTORA V ROM OD ADRESY 'ADLOGO' 128 BYTOV
        MOV     R0,#128         ;POCET TESTOVANYCH BYTOV LOGA
        MOV     R1,#00H         ;VYSLEDOK KONTROLY
        MOV     R2,#00H
TLOGO:  MOV     A,#00H
        MOVC    A,@A+DPTR
        ADD     A,R1
        MOV     R1,A
        MOV     A,#00H
        ADDC    A,R2
        MOV     R2,A
        INC     DPTR
        DJNZ    R0,TLOGO
        MOV     A,R1            ;TEST CI JE KONTROLNA SUMA V PORIADKU
        XRL     A,#LOW(MAGIC)
        JNZ     ERLOGO          ;OPAKUJ TEST AK JE CHYBA V 'LOGu' ROM
        MOV     A,R2
        XRL     A,#HIGH(MAGIC)
        JNZ     ERLOGO
;
TROM:   MOV     DPTR,#0000H     ;TEST 'ROM' ADRIES (0000 .. (DATROM-1))
        MOV     R1,#00H         ;VYSLEDOK KONTROLY
        MOV     R2,#00H
TROM0:  MOV     A,#LOW(DATROM)
        XRL     A,DPLR
        JNZ     TROM1
        MOV     A,#HIGH(DATROM)
        XRL     A,DPHR
        JZ      SROM
TROM1:  MOV     A,#00H
        MOVC    A,@A+DPTR
        ADD     A,R1
        MOV     R1,A
        MOV     A,#00H
        ADDC    A,R2
        MOV     R2,A
        INC     DPTR
        LJMP    TROM0
SROM:   MOV     DPLR,#LOW(DATROM)
        MOV     DPHR,#HIGH(DATROM)
;!!!    LJMP    ZAROM           ;PRESKOCENIE TESTU SPRAVNOSTI VYSLEDKU
        MOV     A,#00H
        MOVC    A,@A+DPTR
        XRL     A,R2            ;HORNY BYTE SUMY
        JNZ     TROM
        INC     DPTR
        MOV     A,#00H
        MOVC    A,@A+DPTR
        XRL     A,R1            ;DOLNY BYTE SUMY
        JNZ     TROM
;
        MOV     R1,#00H
        MOV     R2,#00H
;
ZAROM:  MOV     DPTR,#ADRLED    ;VYPNI LED DIODY PO UKONCENI TESTOV uP A PAMATI RWM, ROM
        MOV     A,#0FFH
        MOVX    @DPTR,A
        MOV     SP,#30H         ;NASTAVENIE ZASOBNIKA 30H - 7FH ( max. 80 BYTOV )
        LJMP    INICI           ;SKOK NA INICIALIZACIU 'HW' A 'SW'
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INICIALIZACIA PARAMETROV PROGRAMU A uPROCESORA 80C31,87C51
; =SW=
INIC:   NOP                     ;INICIALIZACIA PARAMETROV SW A HW
        MOV     INTTIM,#00H     ;NULUJ POCITADLO POLPERIOD 18KHz
        MOV     DPTR,#0000H     ;NASTAV POCITADLO ADRIES OBJEKTOV - PRVY OBJEKT (KZ 1)
        MOV     LONGBU,#00H     ;NULUJ DLZKU PRIJIMACIEHO BUFFRA Z 'PC'
        MOV     LONRET,#00H     ;NULUJ DLZKU VYSIELACIEHO BUFFRA DO 'PC'
        MOV     BCC,#00H        ;NULUJ BYTE KONTROLNEHO SUCTU
        MOV     STAV,#PTAMER    ;NULUJ AKTIVNY STAV 'TAMPER' + 'PRIRADENIE'
        CLR     EN18            ;ZABLOKUJ GENERATOR 18 KHz
        CLR     MUXOK           ;NEAKTIVNA KOMUNIKACIA S 'MULTIPLEXEROM'
        CLR     AKTPRT          ;NEAKTIVNY KOMUNIKACNY PROTOKOL
        CLR     TBIT            ;NULUJ POMOCNY BIT
        CLR     AKTOBJ          ;NEAKTIVNY PODPROGRAM OBJEKT
        CLR     NOINCR          ;NULUJ POZIADAVKU NA NENASTAVENIE DALSIEHO 'KZ'
        CLR     RESATU          ;NIE JE AKTIVNA POZIADAVKA NA RESET 'ATU'
        CLR     ISCRC           ;NULUJ POZIADAVKU NA 'HIGH SECURITY' PROTOKOL
        CLR     CYC512          ;NULUJ POCITADLO MODULO 512 'KZ'
        MOV     POM1,#00H
        MOV     POM2,#00H
        MOV     EROR18,#00H     ;NULUJ PRIZNAK CHYBY VYSIELANIA BYTU DO 'KZ'
        MOV     POBJ1,#00H
        MOV     POBJ2,#00H
        MOV     POBJ3,#OBJMAX
        MOV     MWORK1,#5
        MOV     MWORK2,#3
        MOV     RXKZER,#00H
        MOV     ERCRC,#00H
        MOV     POML,#00H       ;NASTAV ADRESU PRVEHO 'KZ' PRE REZIM 'HIGH SECURITY'
        MOV     POMH,#00H
        MOV     GENCRC,#80H     ;NASTAV POCIATOCNU STARTOVACIU HODNOTU GENERATORA 'CRC'
        MOV     MAXREP,#REPMAX  ;NASTAV MAX. POCET PRIJMOV BYTOV Z JEDNEHO 'KZ'
        MOV     CYCLES,#MAXCYC  ;NASTAV min. POZADOVANY POCET TESTOV 'KZ'
        MOV     ATSFLG,#00H     ;NULUJ SYSTEMOVE PRIZNAKY
        SETB    AKTCRC          ;NASTAVENIE AKTIVITY 'CRC' PROTOKOLU
        MOV     A,#SETCRC       ;TEST UZIVATELSKEJ 'SW' POZIADAVKY
        CJNE    A,#00H,SETHW    ;SKOK AK NIE JE AKTIVNY 'CRC' PROTOKOL
        CLR     AKTCRC          ;NASTAV AKTIVNY 'CRC' PROTOKOL
        SETB    TSTCRC          ;NASTAV PRIZNAK TESTOV 'CRC' - SPOJENIE 'OK !'
; =HW=
SETHW:  MOV     TMOD,#00100010B ;GATE1=0,C/T'=0,MOD1=2 ( 8 BIT AUTO)
                                ;GATE0=0,C/T'=0,MOD0=2 ( 8 BIT AUTO)
        MOV     TH1,#63         ;8 BITOVY AUTOMATICKY OBNOVOVANY CITAC
        MOV     TL1,#63         ;#63 => 149.22 BIT/sekunda
        MOV     TH0,#230        ;26 TAKTOV =28.2 us (PRERUSENIE ZA 28 us)
        MOV     TL0,#230
        MOV     TCON,#01010101B ;TF1=0,TR1=1,TF0=0,TR0=1,IE1=0,IT1=1,IE0=0,IT0=1
        MOV     PCON,#00H       ;SMOD=0,GF1=GF0=0,PD=IDL=0
        MOV     SCON,#01010010B ;MOD=1(8 BIT),SM2=0,REN=1,TB8=RB8=0,TI=1,RI=0
        MOV     IP,#00000000B   ;0,0,PT2=0,PS=0,PT1=0,PX1=0,PT0=0,PX0=0 (PRIORITA[H,.,L] - PT1,IE0,PT0)
        MOV     IE,#10000010B   ;EA=1,0,ET2=0,ES=0,ET1=0,EX1=0,ET0=1,EX0=0
;
;INICIALIZACNY TEST AKTIVITY MODEMU 2600 Hz
;(MODEM NIE JE MOZNE TESTOVAT LEBO SU V CESTE TX, RX JUMPERY !!!)
        MOV     DPTR,#ADRLED    ;ZAPNI DOLNE 4 LED DIODY
        MOV     A,#0F0H
        MOVX    @DPTR,A
        MOV     DPTR,#0000H
        CALL    TIM5MS
        CALL    TIM5MS
;INICIALIZACNY TEST AKTIVITY MODEMU 18 KHz
        MOV     DPTR,#ADRLED    ;ZAPNI HORNE 4 LED DIODY
        MOV     A,#0FH
        MOVX    @DPTR,A
        MOV     DPTR,#0000H
E18M:   SETB    EN18            ;ZAPNI 18 KHz MODEM NA min. 5 ms
        CALL    TIM5MS
        JB      R18,E18M        ;SKOK NA CYKLUS CHYBY AK PRIJIMAC NEDETEKUJE 18 KHz
        CLR     EN18
;INICIALIZACNY TEST AKTIVITY =HW= DOSIEK FILTROV
        MOV     DPTR,#0000H     ;NULUJ POCITADLO ADRIES LINIEK
        MOV     POM1,#64        ;NASTAV POCET TESTOVANYCH DOSIEK FILTROV
ADRFI0: MOV     POM2,#8         ;NASTAV POCET LINIEK NA JEDNEJ DOSKE FILTROV
ADRFI1: CALL    SETOBJ          ;ZASVIET LED ADRESOVANEJ DOSKY FILTROV
        INC     DPTR
        ANL     DPHR,#01H       ;NASTAV ADRESU NASLEDUJUCEJ LINKY
        CALL    TIM4MS          ;CAKAJ 4 ms NA LINKE ( 32 ms NA JEDNEJ DOSKE => 2,048 sek. 512 LINIEK)
        DJNZ    POM2,ADRFI1
        DJNZ    POM1,ADRFI0
        MOV     DPTR,#ADRLED    ;VYPNI LED DIODY PO UKONCENI TESTOV
        MOV     A,#0FFH
        MOVX    @DPTR,A
        MOV     DPTR,#0000H     ;NASTAV POCITADLO ADRIES OBJEKTOV - PRVY OBJEKT (KZ 1)
        MOV     P1,DPLR         ;NASTAV NA PORTY ADRESU Z POCITADLA ADRIES OBJEKTOV
        CLR     PA8
        MOV     POM2,#5         ;6 x 100 ms
        MOV     DPTR,#ADRLED
        MOV     A,#0FFH
        MOVX    @DPTR,A         ;ZHASNI LED DIODY
        MOV     B,#0FFH
        JNB     AKTCRC,AKTNUL   ;TEST AKTIVITY CRC POLYNOMU
BLIPOC: MOV     POM1,#20        ;2 x BLIKNU VSETKY LED DIODY AK JE AKTIVNY 'CRC' PROTOKOL
BLIKSW: CALL    TIM5MS
        DJNZ    POM1,BLIKSW
        MOV     A,B
        XRL     A,#0FFH
        MOV     B,A
        MOVX    @DPTR,A
        DJNZ    POM2,BLIPOC
AKTNUL: MOV     DPTR,#ADRLED    ;VYPNI LED DIODY PO UKONCENI TESTOV
        MOV     A,#0FFH
        MOVX    @DPTR,A
        MOV     DPTR,#0000H
        LJMP    KOLO            ;NAVRAT DO HLAVNEHO PROGRAMU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MAIN:   JNB     RESATU,NORE     ;HLAVNA SLUCKA PROGRAMU
        CLR     RESATU
        ANL	IE,#00H	        ;ZABLOKUJ VSETKY PRERUSENIA
	MOV     IP,#00H	        ;NASTAV ROVNAKE UROVNE PRERUSENI
	MOV	TMOD,#00H       ;NULUJ NASTAVENIA CASOVACOV
	MOV	PSW,#00H        ;NULUJ STAVOVY REGISTER
	MOV	P1,#0FFH        ;NASTAV JEDNOTKY NA VYSTUP P1
	MOV	P3,#0FFH        ;NASTAV JEDNOTKY NA VYSTUP P3
	MOV	SP,#07H	        ;NASTAV POCIATOCNU ADRESU ZASOBNIKA
        LJMP    STRT
;
NORE:   JB      MUXOK,NOPRIR    ;TEST CI GENERUJE 'POZIADAVKU NA PRIRADENIE'
        MOV     STAV,#PTAMOK    ;GENERUJ 'POZIADAVKU' A STAV 'TAMPER OK'
        JNB     TAM,ZASTAV
        MOV     STAV,#PTAMER    ;GENERUJ 'POZIADAVKU' A STAV 'TAMPER ERROR'
        LJMP    ZASTAV
NOPRIR: MOV     STAV,#TAMOK     ;GENERUJ LEN STAV 'TAMPER OK'
        JNB     TAM,ZASTAV
        MOV     STAV,#TAMER     ;GENERUJ LEN STAV 'TAMPER ERROR'
ZASTAV: NOP
;
MXRING: JNB     RI,NOKOM        ;TEST CI PRISLA VYZVA NA KOMUNIKACIU S 'MUXom'
        CALL    PROTOK          ;OBSLUHA KOMUNIKACNEHO PROTOKOLU
        LJMP    MXRING
NOKOM:  JB      ISCRC,NOKO2     ;SKOK NA 'CRC', AK Z NEHO MUSEL VYSKOCIT PRE DATA Z 'MUXu'
        ANL     DPHR,#01H       ;MASKA LEN PRE 512 OBJEKTOV MAXIMALNE
        MOVX    A,@DPTR         ;CINNOST S JEDNYM OBJEKTOM NESMIE BYT DLHSIA AKO 140 ms !!!
        CJNE    A,#55H,NOTOBJ   ;SKOK AK OBJEKT NIE JE PRIRADENY
        CALL    SETOBJ          ;NASTAV 'HW' SELEKCIU AKTUALNEHO OBJEKTU
        CALL    OBJEKT          ;OBSLUHA OBJEKTU - TEST KOMUNIKACIE
;=CRC=
        JB      NOINCR,NOTINC   ;PRESKOC 'CRC' PROTOKOL AK IDE O ROVNAKE 'KZ' AK V PRED. KROKU
        JNB     AKTCRC,AFTCRC   ;SKOK AK NIE JE AKTIVNY 'CRC' PROTOKOL
        JNB     CYC512,KOL0     ;'CRC' JE AKTIVNE IBA POCAS NEPARNYCH CYKLOV MODULO 512 'KZ' !
        MOV     A,CYCLES        ;TEST CI UPLYNULA MIN. POZADOVANA DOBA MEDZI DVOMA 'CRC'
        CJNE    A,#00H,KOL0     ;AK NEUPLYNUL MIN. CAS MEDZI VYMENAMI VYNECHA PROTOKOL 'CRC'
        JNB     TSTCRC,KOL0     ;NETESTUJ 'CRC' POKIAL NIE JE SPRAVNA KOMUNIKACIA S 'MUXom'
        CLR     CYC512          ;NULUJ PRIZNAK PRACOVNEJ PBLASTI 'CRC'
        MOV     CYCLES,#MAXCYC  ;NASTAV POCET POZADOVANYCH TESTOV 'KZ' (min. CAS ONESKORENIA)
MXRIN1: JNB     RI,NOKO2        ;TEST CI PRISLA VYZVA NA KOMUNIKACIU S 'MUXom'
        CALL    PROTOK          ;OBSLUHA KOMUNIKACNEHO PROTOKOLU
        LJMP    MXRIN1
NOKO2:  CALL    SECUR           ;VOLA PODPROGRAM REZIMU 'HIGH SECURITY'
MURING: JNB     RI,NOKOM1       ;TEST CI PRISLA VYZVA NA KOMUNIKACIU S 'MUXom'
        CALL    PROTOK          ;OBSLUHA KOMUNIKACNEHO PROTOKOLU
        LJMP    MURING
NOKOM1: JB      ISCRC,NOKO2
        PUSH    DPLR            ;UCHOVAJ ADRESU SPRACOVAVANEHO 'KZ' V HLAVNEJ SLUCKE
        PUSH    DPHR
        MOV     DPLR,ADCRCL     ;NASTAV ADRESU REALIZOVANEHO 'KZ' V 'SECUR' PODPROGRAME
        MOV     DPHR,ADCRCH
        ANL     DPHR,#01H
        MOVX    A,@DPTR         ;TEST CI IDE O PRIRADENY OBJEKT
        CJNE    A,#55H,LOCRC    ;AK NIE, UKONCI PROCEDURU TESTOVANIA 'KZ'
REPCRC: CALL    SETOBJ          ;NASTAV 'HW' SELEKCIU AKTUALNEHO OBJEKTU 'CRC'
        MOV     CRREAD,#4       ;MAX. POCET NACITAVANYCH BYTOV PO KOMUNIKACII 'CRC'
        CALL    OBJEKT          ;OBSLUHA OBJEKTU 'CRC' - TEST KOMUNIKACIE
        JNB     NOINCR,LOCRC    ;OPAKUJ CITANIE 'KZ' PODLA ADRESY Z 'CRC' PRENOSU
        MOV     A,CRREAD        ;TEST CI VYPRSAL MAX. POVOLENY POCET CITANII 'KZ'
        JZ      LOCRC           ;SKOK AK VYCERPAL MAX. LIMIT CITANI 'KZ'
        DEC     CRREAD
CURING: JNB     RI,REPCRC       ;TEST CI PRISLA VYZVA NA KOMUNIKACIU S 'MUXom'
        CALL    PROTOK          ;OBSLUHA KOMUNIKACNEHO PROTOKOLU
        LJMP    CURING
LOCRC:  POP     DPHR
        POP     DPLR
KOL0:   CLR     NOINCR          ;NULUJ PRE ISTOTO AK BY 'REPCRC:' ZANECHAL = 1 !
        CALL    CRCMSG          ;VYHODNOT KOMUNIKACIU 'CRC' POLYNOMU PRE 'KZ' ADRESOVANE V 'MAIN:'
;=CRC=
AFTCRC: JB      NOINCR,NOTINC   ;TEST CI JE POZIADAVKA NA NENASTAVENIA NOVEHO 'KZ'
NOTOBJ: INC     DPTR            ;NASTAV ADRESU DALSIEHO OBJEKTU
        ANL     DPHR,#01H
        MOV     A,DPHR          ;TEST CI PRESIEL CYKLUS VSETKYCH 512 'KZ'
        ORL     A,DPLR
        CJNE    A,#00H,NOCYC    ;AK ANO - SKOK DO PROGRAMU 'HIGH SECURITY'
        SETB    CYC512          ;ZMEN PRIZNAK PRECHODU 512 'KZ'
NOCYC:  NOP
NOTINC: ANL     DPHR,#01H       ;MASKA LEN PRE 512 OBJEKTOV MAXIMALNE
        PUSH    DPHR
        PUSH    DPLR
        MOV     DPTR,#ADRLED    ;VYPNE LED DIODY SIGNALIZUJUCE AKTIVNY TESTOVANY BLOK
        MOV     A,#0FFH
        MOVX    @DPTR,A
        POP     DPLR
        POP     DPHR
;
        LJMP    KOLO            ;CYKLUS HLAVNEJ SLUCKY
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SETOBJ: PUSH    PSW             ;POTREBUJE 8 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    POM1
        PUSH    POM2
        PUSH    DPHR
        PUSH    DPLR
        MOV     POM1,DPLR
        MOV     POM2,DPHR
        MOV     A,POM2          ;ZISTI REALNU HODNOTU NAJVYSSIEHO BITU
        JNB     ACC.0,ISCLR
        SETB    PA8             ;NASTAV NAJVYSSI ADRESNY BIT
        LJMP    PA8SET
ISCLR:  CLR     PA8             ;NULUJ NAJVYSSI ADRESNY BIT
PA8SET: NOP
;PREPOCET POZICIE LINKY NA KONEKTORE
        ANL     DPLR,#0F8H      ;PREPOCET HODNOTY NAJNIZSICH 3. BITOV
        MOV     A,POM1
        ANL     A,#07H          ;MASKUJ NAJNIZSIE 3. BITI REALNEJ ADRESY
        ADD     A,#3            ;OFFSET MEDZI INSTRUKCIOU A ADRESOU DAT PREPOCTU
        MOVC    A,@A+PC
        LJMP    ZAPREP
KODPRE: DB      06H,04H,05H,07H ;KZ(000)=(006),KZ(001)=(004),KZ(002)=(005),KZ(003)=(007)
        DB      03H,02H,01H,00H ;KZ(004)=(003),KZ(005)=(002),KZ(006)=(001),KZ(007)=(000)
ZAPREP: ANL     A,#07H          ;MASKUJ NAJNIZSIE TRI BITI
        ORL     DPLR,A
        MOV     P1,DPLR
;KONIEC PREPOCTU POZICIE LINKY NA KONEKTORE
        MOV     DPTR,#ADRLED
        MOV     A,#0FFH
        MOVX    @DPTR,A         ;VYPNE VSETKY LED DIODY
        MOV     A,POM1
        RL      A
        RL      A
        ANL     A,#03H
        MOV     POM1,A
        MOV     A,POM2
        RL      A
        RL      A
        ANL     A,#04H
        ORL     A,POM1
        MOV     POM2,A          ;V POM2 SA NACHADZA CISLO LED KTORA MA SVIETIT
        ANL     POM2,#07H
        INC     POM2
        MOV     A,#0FFH
        CLR     C
ROTLED: RRC     A
        DJNZ    POM2,ROTLED
        MOVX    @DPTR,A         ;ZASVIETI LEN PRISLUSNU LED DIODU
        CALL    TIM1MS          ;NASTAV CAS CAKANIA 1 ms - USTALENIE 'HW' LINKY 'KZ'
        POP     DPLR
        POP     DPHR
        POP     POM2
        POP     POM1
        POP     ACC
        POP     PSW
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
PROTOK: CLR     RI              ;NULUJ PRIZNAK PRIJMU BYTU Z 'MUXu'
        JNB     AKTPRT,RUNPRT   ;KOMUNIKACNY PROTOKOL S MULTIPLEXEROM
        LJMP    AREPRT          ;ZABLOKUJ 'REKURZIVNY' ALGORITMUS
RUNPRT: SETB    AKTPRT          ;PRIZNAK, ZE JE AKTIVNY KOMUNIKACNY PROTOKOL
        PUSH    PSW             ;POTREBUJE 6 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    DPLR            ;UCHOVAJ CISLO AKTIVNEHO OBJEKTU
        PUSH    DPHR
        MOV     A,SBUF
        MOV     LONGBU,#00H     ;NULUJ DLZKU PRIJIMACIEHO BUFFRA Z 'MUXu'
        CJNE    A,#GETST,ENDPRT ;SKOK AK NEJDE O POZIADAVKU NA 'STAV'
        MOV     DPTR,#ADRLED    ;ZAPNE VSETKY 'LED DIODY' - KOMUNIKACNY PROTOKOL
        MOV     A,#00H
        MOVX    @DPTR,A
        LJMP    ISPROT
ENDPRT: MOV     A,LONGBU
        JZ      RXBUCL          ;SKOK AK JE PRIJIMACI BUFFER PRAZDNY
        MOV     A,LONGBU        ;TEST CI JE V BUFFRI PARNY POCET UDAJOV !!!
        JNB     ACC.0,ISPAR
        MOV     LONGBU,#00H     ;NULUJ DLZKU PRIJIMACIEHO BUFFRA - NEPARNY POCET BYTOV
        LJMP    RXBUCL          ;CHYBNY OBSAH PRIJIMACIEHO BUFFRA
ISPAR:  LJMP    RXZRUS          ;OBSLUHA PRIJIMACIEHO BUFFRA
RXBUCL: MOV     DPTR,#ADRLED    ;VYPNE VSETKY 'LED DIODY' - KOMUNIKACNY PROTOKOL
        MOV     A,#0FFH
        MOVX    @DPTR,A
        POP     DPHR            ;OBNOV CISLO AKTIVNEHO OBJEKTU
        POP     DPLR
        POP     ACC
        POP     PSW
        CLR     RI              ;PRI NAVRATE Z PROTOKOLU JE PRAZDNY PRIJ. REG. SER. LINKY
        CLR     AKTPRT          ;PRIZNAK UKONCENIA CINNOSTI KOMUNIKACNEHO PROTOKOLU
AREPRT: RET
ISPROT: SETB    TSTCRC          ;NASTAV PRIZNAK SPRAVNEHO NADVIAZANIA KOMUNIKACIE S 'MUXom'
        CLR     ATSTX           ;NASTAV PRIZNAK VNUTENEHO VYSLANIA STAVU 'ATS' (BUFFER MA SPRAVU PRE PC)
        CALL    TIM5MS          ;CAKAJ 10 ms (RI MOZE BYT ZACHYTENE V STREDE STOP IMPULZU)
        CALL    TIM5MS
        MOV     A,LONRET        ;TEST CI MA VYSLAT BUFFER Z 'ATS' - JE PRAZDNY ?
        JZ      TXSTAV          ;AK ANO, VYSLE STAVOVU INFORMACIU
        JNB     ATSBUF,TXBU1
        SETB    ATSTX           ;NASTAV PRIZNAK VNUTENEHO VYSLANIA STAVU 'ATS' DO 'PC'
        LJMP    TXSTAV
TXBU1:  LJMP    TXBUFF          ;AK NIE JE BUFFER PRAZDNY, VYSLE JEHO OBSAH NA 'MUX'
;
TXSTAV: CLR     ATSBUF          ;NASTAVENIE DO '0' ZNAMENA, ZE POSLEDNY BOL VYSIELANY STAV 'ATS'
        JNB     TI,$            ;CAKA NA POVOLENIE VYSIELAT SERIOVOU LINKOU
        CLR     TI
        MOV     SBUF,STAV       ;VYSLE STAVOVU INFORMACIU (AK JE BUFFER PRAZDNY)
        JNB     TI,$            ;CAKA NA DOVYSIELANIE BYTU 'STAV'
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        MOV     PTIM1,#3        ;NASTAV CAS CAKANIA NA ODPOVED Z 'MUX' NA max. 1.5 sek.
WAI0:   MOV     PTIM2,#100      ;3 x 100 x (5 ms) = 1.5 s
WAI1:   CALL    TIM5MS          ;CAKAJ 5 ms
        JB      RI,RX1          ;SKOK AK NIECO PRISLO Z 'MUX' DO 1.5 s
        DJNZ    PTIM2,WAI1
        DJNZ    PTIM1,WAI0
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        CLR     TSTCRC          ;NIE JE SPRAVNE NADVIAZANIE KOMUNIKACIE S 'MUXom'
        LJMP    ENDPRT          ;VYSKOCI PO UPLYNUTI 1.5 s DO HLAVNEJ SLUCKY
RX1:    CLR     RI
        MOV     A,SBUF          ;TEST PRIJATEJ ODPOVEDE Z 'MUXu'
        CJNE    A,#MUXACK,NOACK ;'MUX' SPRAVNE PRENIESOL SPRAVU DO 'PC' ?
;       SETB    MUXOK           ;PRIZNAK, ZE UZ NEMUSIM GENEROVAT POZIADAVKU NA PRIRADENIE 'KZ'
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ENDPRT          ;KONIEC PROTOKOLU
NOACK:  CJNE    A,#MUXNAK,NONAK ;'MUX' NEDOSTAL POTVRDENIE Z 'PC'
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ENDPRT
NONAK:  CJNE    A,#GETST,NOGET  ;TEST CI 'ATU' NEVYNECHALO CYKLUS (SLUCKA > 140 ms V 'MAIN:')
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ISPROT          ;SKOK NA ZACIATOK PROTOKOLU
NOGET:  MOV     LONGBU,A        ;UCHOVAJ PRIPADNU DLZKU BUFFRA Z 'PC' (NESMIE IST O 'GETST')
        ADD     A,#56H          ;TEST CI DLZKA SPRAVY JE > AAH (170 BYTOV - REAL max. 168)
        JNC     ISMESS          ;SKOK NA PRIJEM SPRAVY
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ENDPRT          ;CHYBNE POTVRDENIE 'STAVu' Z 'MUXu' A 'PC'
ISMESS: MOV     DPTR,#ADRLED    ;ZAPNE PRIJEM 'LED DIODY'(0,1,2,3) - KOMUNIKACNY PROTOKOL
        MOV     A,#0FH
        MOVX    @DPTR,A
        CALL    TIM5MS          ;CAKAJ 10 ms
        CALL    TIM5MS
        JNB     TI,$            ;CAKA NA POVOLENIE VYSIELAT SERIOVOU LINKOU
        CLR     TI
        MOV     A,#RENAK        ;AK BOL VNUTENE VYSIELANY STAV 'ATS' NEPREBERIE SPRAVU Z 'PC'
        JB      ATSTX,WRAP
        MOV     A,#REACK        ;NORMALNE PREVZATIE SPRAVY Z 'MUXu' A 'PC'
WRAP:   MOV     SBUF,A          ;ODPOVED PRIPRAVENOSTI PRIJAT SPRAVU Z 'MUXu - PC'
        JNB     TI,$            ;CAKA NA DOVYSIELANIE BYTU
        JNB     RI,$
        CLR     RI              ;NULUJ VLASTNE ECHO
        JNB     ATSTX,NOWRAP
        MOV     LONGBU,#00H     ;NASTAV NULOVU DLZKU PRIJATEJ SPRAVY
        CALL    TIM5MS
        LJMP    ENDPRT          ;UKONCI KOMUNIKACNY PROTOKOL PRI VNUTENOM VYSIELANI STAVU 'ATS'
NOWRAP: MOV     DPTR,#PCBUF     ;NASTAV POCIATOCNU ADRESU PRIJIMACIEHO BUFFRA
        MOV     BCC,#00H        ;NULUJ KONTROLNY SUCET
RXBYTE: MOV     PTIM1,#60       ;NASTAV CAKANIE max. 60 x 5 = 300 ms
WAI2:   CALL    TIM5MS
        JB      RI,RX2
        DJNZ    PTIM1,WAI2
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ENDPRT          ;UKONCI PROTOKOL AK VYPRSAL CAS 300 ms CAKANIA BYTU Z 'MUXu'
RX2:    CLR     RI
        MOV     A,SBUF          ;ULOZ PRIJATY BYTE DO BUFFRA A VYPOCITAJ 'BCC'
        XRL     BCC,A
        MOVX    @DPTR,A
        INC     DPTR            ;DALSIA ADRESA V PRIJIMACOM BUFFRI
        MOV     A,LONGBU
        INC     A
        XRL     A,DPLR          ;TEST CI JE PRIJATA CELA SPRAVA + 'BCC'
        JNZ     RXBYTE
        CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM ODPOVEDE DO 'MUXu'
        CALL    TIM5MS
        MOV     B,#ACK          ;PRIZNAK SPRAVNEHO PRIJMU SPRAVY
        MOV     A,BCC
        JNZ     NORXOK          ;TEST CI JE SPRAVA DOBRE PRIJATA
;       SETB    MUXOK
        LJMP    ISRXOK
NORXOK: MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        MOV     B,#NAK          ;PRIZNAK CHYBNEHO PRIJMU SPRAVY
ISRXOK: JNB     TI,$            ;CAKA NA POVOLENIE VYSIELAT SERIOVOU LINKOU
        CLR     TI
        MOV     SBUF,B          ;VYSLE POTVRDENIE PRIJMU SPRAVY Z 'MUXu'
        JNB     TI,$            ;CAKA NA DOVYSIELANIE POTVRDENIE
        JNB     RI,$            ;NULUJE VLASTNE ECHO
        CLR     RI
        LJMP    ENDPRT          ;UKONCENIE KOMUNIKACNEHO PROTOKOLU
;
TXBUFF: MOV     A,#105          ;VYSLANIE BUFFRA DO 'MUXu' (max. DLZKA JE 150 BYTOV)
        ADD     A,LONRET
        JNC     ISBUOK
        MOV     LONRET,#00H     ;NULUJ VYSIELACI BUFFER AK JE > 150 BYTOV
        LJMP    TXSTAV          ;POKRACUJE AKO KEBY BOL VYSIELACI BUFFER PRAZDNY
ISBUOK: MOV     DPTR,#ADRLED    ;ZAPNE VYSIELANIE 'LED DIODY'(4,5,6,7) - KOMUNIKACNY PROTOKOL
        MOV     A,#0F0H
        MOVX    @DPTR,A
        SETB    ATSBUF          ;NASTAVENIE DO '1' ZNAMENA, ZE POSLEDNY BOL VYSIELANY BUFFER
        JNB     TI,$            ;CAKA NA POVOLENIE VYSIELAT SERIOVOU LINKOU
        CLR     TI
        MOV     SBUF,LONRET     ;VYSLE DLZKU BUFFRA
        JNB     TI,$            ;CAKA NA DOVYSIELANIE BYTU 'LONRET'
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        MOV     PTIM1,#60       ;NASTAV CAS CAKANIA max. 0.3 s NA ODPOVED Z 'MUX'
WAI3:   CALL    TIM5MS
        JB      RI,RX3
        DJNZ    PTIM1,WAI3
        CLR     TSTCRC          ;NIE JE SPRAVNE NADVIAZANIE KOMUNIKACIE S 'MUXom'
        LJMP    ENDPRT          ;UKONCI PROTOKOL PRI CHYBE
RX3:    CLR     RI
        MOV     A,SBUF          ;TEST PRIJATEJ ODPOVEDE
        CJNE    A,#ACK,NOOKBU
        LJMP    TXBUOK          ;VYSLI OBSAH VYSIELACIEHO BUFFRA 'ATS' DO 'MUX'
NOOKBU: CJNE    A,#GETST,NOGET1 ;TEST CI 'ATU' NEVYNECHALO CYKLUS (SLUCKA > 140 ms V 'MAIN:')
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ISPROT          ;SKOK NA ZACIATOK PROTOKOLU
NOGET1: LJMP    ENDPRT
TXBUOK: CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM BUFFRA DO 'MUX'
        CALL    TIM5MS
        JNB     TI,$            ;CAKAJ NA POVOLENIE VYSIELANIA DO 'MUX'
        CLR     TI
        MOV     SBUF,#01H       ;VYSLI KOD 01H (CISLO LINKY 'ATS' MODULU ALEBO VERZIE 'SW')
        JNB     TI,$            ;CAKAJ NA DOVYSIELANIE
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        MOV     BCC,#00H        ;NULUJ 'BCC' POLYNOM
        MOV     DPTR,#RETBUF    ;NASTAV POCIATOCNU ADRESU VYSIELACIEHO BUFFRA
TXBYTE: CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM DAVKY BYTOV Z BUFFRA
        CALL    TIM5MS
        JNB     TI,$
        CLR     TI              ;CAKA NA POVOLENIE VYSIELANIA SERIOVOU LINKOU
        MOVX    A,@DPTR         ;NACITAJ UDAJ Z BUFFRA
        XRL     BCC,A           ;VYPOCITAJ 'BCC' POLYNOM
        MOV     SBUF,A          ;VYSLI UDAJ
        JNB     TI,$            ;CAKAJ NA DOVYSIELANIE BYTU BUFFRA
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        INC     DPTR            ;NASTAV DALSI UDAJ Z BUFFRA
        MOV     A,DPLR
        XRL     A,LONRET        ;TEST CI SU VYSLANE VSETKY BYTY  BUFFRA
        JNZ     TXBYTE
        CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM 'BCC'
        CALL    TIM5MS
        JNB     TI,$
        CLR     TI
        MOV     SBUF,BCC        ;VYSLI 'BCC' POLYNOM
        JNB     TI,$            ;CAKAJ NA DOVYSIELANIE
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        MOV     PTIM1,#3        ;NASTAV CAS CAKANIA NA ODPOVED Z 'MUX' NA max. 1.5 sek.
WAI4:   MOV     PTIM2,#100      ;3 x 100 x (5 ms) = 1.5 s
WAI5:   CALL    TIM5MS          ;CAKAJ 5 ms
        JB      RI,RX4          ;SKOK AK NIECO PRISLO Z 'MUX' DO 1.5 s
        DJNZ    PTIM2,WAI5
        DJNZ    PTIM1,WAI4
        LJMP    ENDPRT          ;UKONCI PROTOKOL PO UPLYNUTI 1.5 s
RX4:    CLR     RI
        MOV     A,SBUF          ;NACITAJ PRIJATU ODPOVED Z 'MUX'
        CJNE    A,#ACK,NOISOK
        MOV     LONRET,#00H     ;NULUJ VYSIELACI BUFFER
        MOV     B,#REACK        ;SPRAVNE UKONCENIE PROTOKOLU
        CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM ODPOVEDE
        CALL    TIM5MS
        JNB     TI,$
        CLR     TI
        MOV     SBUF,B
        JNB     TI,$
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        LJMP    ENDPRT          ;UKONCI PROTOKOL
NOISOK: CJNE    A,#NAK,NAKNOT
        LJMP    NAKJE
NAKNOT: CJNE    A,#GETST,NOGET2 ;TEST CI NIE JE ZACIATOK SYNCHRONIZACIE PROTOKOLU
        MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    ISPROT          ;SKOK NA ZACIATOK PROTOKOLU
NOGET2: LJMP    ENDPRT          ;UKONCI PROTOKOL PRI NESPRAVNEJ ODPOVEDI Z 'MUXu'
NAKJE:  MOV     LONRET,#00H     ;NULUJ VYSIELACI BUFFER
        MOV     B,#REACK        ;POVOL PRIJEM SPRAVY Z 'MUXu' AK JE PRIJIMACI BUF. PRAZDNY
        MOV     A,LONGBU
        JZ      REOK
        MOV     B,#RENAK        ;NEDOVOLI PRIJEM Z 'MUXu' - PRIJIMACI BUFFER JE PLNY
REOK:   CALL    TIM5MS          ;CAKAJ 10 ms PRED VYSLANIM ODPOVEDE
        CALL    TIM5MS
        JNB     TI,$
        CLR     TI
        MOV     SBUF,B
        JNB     TI,$
        JNB     RI,$            ;NULUJ VLASTNE ECHO
        CLR     RI
        MOV     A,#REACK
        XRL     A,B
        JZ      JEPRIJ          ;POVOLENIE PRIJMU SPRAVY Z 'MUXu'
        LJMP    ENDPRT          ;UKONCI PROTOKOL AK PRIJIMACI BUFFER NIE JE PRAZDNY
JEPRIJ: MOV     PTIM1,#60       ;CAKAJ max. 300 ms NA PRIJEM BYTU DLZKY SPRAVY
WAI6:   CALL    TIM5MS
        JB      RI,RX5
        DJNZ    PTIM1,WAI6
        LJMP    ENDPRT          ;UKONCI PROTOKOL PRI CHYBE
RX5:    CLR     RI
        MOV     A,SBUF
        LJMP    NOGET           ;POKRACUJE V CASTI PROGRAMU - PRIJEM SPRAVY Z 'MUXu'
;
RXZRUS: MOV     POM3,LONGBU     ;OBSLUHA PRIJIMACIEHO BUFFRA Z 'MUXu'
        MOV     DPTR,#PCBUF     ;NASTAV ADRESU ZACIATKU PRIJIMACIEHO BUFFRA
BUKOLO: MOVX    A,@DPTR         ;NACITAJ KOD + NAJVYSSI ADRESNY BIT
        MOV     POM1,A          ;KOD SPRAVY
        INC     DPTR
        MOVX    A,@DPTR
        MOV     POM2,A          ;DOLNY BYTE ADRESY OBJEKTU
        INC     DPTR            ;UKAZUJE NA DALSIU 'DVOJICU BYTOV SPRAVY'
        MOV     A,POM1
        ANL     A,#07FH         ;TEST TYPU PRIJATEHO KODU
        CJNE    A,#RESATS,NORES ;TEST CI IDE O 'SW' RESET 'ATS'
        SETB    RESATU          ;NASTAV AKTIVNY PRIZNAK NA 'SW' RESET 'ATU'
        LJMP    STBUF
NORES:  MOV     A,POM1
        ANL     A,#70H          ;MASKUJ LEN HORNE TRI BITY
        CJNE    A,#PRIRAD,NOPRI ;TEST CI IDE O POVEL PRIRADENIA OBJEKTU
        CALL    PRIRKZ
        LJMP    STBUF
NOPRI:  CJNE    A,#ODRAD,NOODRA ;TEST CI IDE O POVEL ODRADENIA OBJEKTU
        CALL    ODRAKZ
        LJMP    STBUF
NOODRA: CJNE    A,#DOTAZ,NODOTA ;TEST CI IDE O POVEL DOTAZU NA OBJEKT
        CALL    DOTAKZ
        LJMP    STBUF
NODOTA: CJNE    A,#KVIT,NOKVIT  ;TEST CI IDE O POVEL ZASVIETENIA LED NA OBJEKTE
        CALL    KVITKZ
        LJMP    STBUF
NOKVIT: CALL    HDUPLX          ;PODROGRAM POLODUPLEXNEJ KOMUNIKACIE
STBUF:  DEC     LONGBU
        MOV     A,LONGBU
        JZ      BUFST
        DEC     LONGBU
        MOV     A,LONGBU
        JZ      BUFST
        LJMP    BUKOLO          ;SPRACOVANIE DALSIEHO POVELU Z PRIJIMACIEHO BUFFRA
BUFST:  MOV     LONGBU,#00H     ;NULUJ PRIJIMACI BUFFER
        LJMP    RXBUCL          ;UKONCI KOMUNIKACNY PROTOKOL
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DPTR - ADRESA 'KZ', 'B' - KOD SPRAVY, MODIFIKUJE 'LONRET' !
;
PUTBUF: PUSH    PSW             ;POTREBUJE 9 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        PUSH    DPHR
        PUSH    DPLR
        PUSH    PUT1
        PUSH    PUT2
        CLR     FULTXH
        MOV     PUT1,DPLR       ;ULOZENIE DO VYSIELACIEHO BUFFRA
        MOV     PUT2,DPHR
        MOV     DPTR,#RETBUF    ;NASTAV ADRESU VYSIELACIEHO BUFFRA
        MOV     DPLR,LONRET
        MOV     A,#MAXTX        ;TEST CI JE PLNY VYSIELACI BUFFER (max. 150 BYTOV, >149 BYTOV)
        ADD     A,LONRET
        JNC     NOFULL
        SETB    FULTXH
RETPUT: POP     PUT2
        POP     PUT1
        POP     DPLR
        POP     DPHR
        POP     B
        POP     ACC
        POP     PSW
        RET
NOFULL: MOV     A,PUT2
        RR      A
        ANL     A,#80H
        ANL     B,#7FH          ;V 'B' SA NACHADZA KOD SPRAVY
        ORL     A,B
        MOVX    @DPTR,A
        INC     DPTR
        MOV     A,PUT1
        MOVX    @DPTR,A
        INC     DPTR
        MOV     LONRET,DPLR     ;NASTAV DLZKU VYSIELACIEHO BUFFRA
        LJMP    RETPUT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
PRIRKZ: PUSH    DPLR            ;POVEL NA PRIRADENIE 'KZ'
        PUSH    DPHR
        PUSH    PSW             ;POTREBUJE 7 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        MOV     DPTR,#ADPRIR    ;NASTAV PRIZNAKY PRIRADENOSTI V 'RWM'
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2       ;NASTAV ADRESU ODRADOVANEHO 'KZ'
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;NACITAJ PRIZNAK PRIRADENIA 'KZ'
        CJNE    A,#55H,ISODR    ;TEST CI JE ZVOLENE 'KZ' ODRADENE
        MOV     B,#KZERPO       ;POKUS PRIRADIT PRIRADENE ('CHYBA PRIRADENIA/ODRADENIA')
        LJMP    PUTOD1
ISODR : SETB    MUXOK           ;NASTAV PRIZNAK PRE HESLO PRIRADENIA PO RESTARTE
        MOV     B,#KZPRIR       ;PRIZNAK 'PRIRADENIE KZ'
PUTOD:  MOV     A,#55H
        MOVX    @DPTR,A         ;NASTAV PRIZNAK - 'PRIRADENIE KZ'
        CALL    PUTBUF
PUTOD1: MOV     A,B
        XRL     A,#KZPRIR
        JNZ     NODOPR          ;AK BOLO PRIRADENIE - GENERUJ DOTAZ NA 'KZ'
        MOV     DPTR,#ADSTAT    ;NULUJ STAVOVY BYTE OBJEKTU
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,#00H
;       SETB    ACC.BDOTAZ      ;NASTAV POZIADAVKU NA DOTAZ PO PRIRADENI
        MOVX    @DPTR,A
;
        MOV     DPTR,#ADSEC     ;NASTAV PARAMETRE TYPU 'KZ' PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,POM1
        ANL     A,#ATTACH       ;TEST CI POVEL PRIRADENIA = 10H (!HIGH SECURITY TYP 'KZ'=10H)
        JZ      NOCLAS          ;!!!SKOK AK JE KLASICKY TYP ('CRC')
        MOV     A,#00H
        LJMP    ZACLAS
NOCLAS: MOV     A,#55H          ;PRIZNAK SPECIALNEHO TYPU 'KZ'
ZACLAS: MOVX    @DPTR,A         ;ULOZ TYP 'KZ' DO 'RWM'
        MOV     DPTR,#ADBIT     ;NASTAV VSETKY POVELY A POZIADAVKY PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,POM1
        ANL     A,#ATTACH       ;TEST CI POVEL PRIRADENIA = 10H (!HIGH SECURITY TYP 'KZ')
        JZ      NOCLA1          ;!!!SKOK AK JE KLASICKY TYP ('CRC')
        MOV     A,#00H
        LJMP    ZACLA1
NOCLA1: MOV     A,#03H          ;NASTAV POZIADAVKU 'CRC=80H' a '"KZ" - DAJ AKTUALNE CRC'
ZACLA1: MOVX    @DPTR,A
        MOV     DPTR,#ADCRC     ;NASTAV POLYNOM PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,POM1
        ANL     A,#ATTACH       ;TEST CI POVEL PRIRADENIA = 10H (!HIGH SECURITY TYP 'KZ')
        JZ      NOCLA2          ;!!!SKOK AK JE KLASICKY TYP ('CRC')
        MOV     A,#00H
        LJMP    ZACLA2
NOCLA2: MOV     A,#80H          ;NASTAV POLYNOM 'CRC=80H'
ZACLA2: MOVX    @DPTR,A
;
NODOPR: POP     B
        POP     ACC
        POP     PSW
        POP     DPHR
        POP     DPLR
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ODRAKZ: PUSH    DPLR            ;POVEL NA ODRADENIE 'KZ'
        PUSH    DPHR
        PUSH    PSW             ;POTREBUJE 7 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        MOV     DPTR,#ADPRIR    ;NASTAV PRIZNAKY PRIRADENOSTI V 'RWM'
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2       ;NASTAV ADRESU ODRADOVANEHO 'KZ'
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;NACITAJ PRIZNAK PRIRADENIA 'KZ'
        CJNE    A,#55H,ISODRA   ;TEST CI JE ZVOLENE 'KZ' ODRADENE
        MOV     B,#KZODRA
        LJMP    PUTODR
ISODRA: MOV     B,#KZERPO       ;PRIZNAK 'CHYBA PRIRADENIA/ODRADENIA KZ'
PUTODR: MOV     A,#00H
        MOVX    @DPTR,A         ;NASTAV PRIZNAK - 'ODRADENIE KZ'
        CALL    PUTBUF
        POP     B
        POP     ACC
        POP     PSW
        POP     DPHR
        POP     DPLR
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DOTAKZ: PUSH    DPLR            ;POVEL NA DOTAZ 'KZ'
        PUSH    DPHR
        PUSH    PSW             ;POTREBUJE 7 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        MOV     DPTR,#ADPRIR    ;TEST CI JE 'KZ' PRIRADENE
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        CJNE    A,#55H,DNOPR    ;SKOK AK NIE JE PRIRADENE 'KZ'
        MOV     DPTR,#ADSTAT    ;NASTAV STAVOVY REGISTER OBJEKTU
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2       ;NASTAV ADRESU DOTAZOVANEHO 'KZ', POMOCNY STAVOVY REGISTER
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;NACITAJ STAVOVY BYTE OBJEKTU
        SETB    ACC.BDOTAZ
        MOVX    @DPTR,A         ;NASTAV PRIZNAK - 'DOTAZ KZ'
RETDOT: POP     B
        POP     ACC
        POP     PSW
        POP     DPHR
        POP     DPLR
        RET
DNOPR:  MOV     B,#KZERPO       ;PRIZNAK 'CHYBA PRIRADENIA/ODRADENIA KZ'
        CALL    PUTBUF
        LJMP    RETDOT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
KVITKZ: PUSH    DPLR            ;POVEL NA KVIT 'KZ'
        PUSH    DPHR
        PUSH    PSW             ;POTREBUJE 7 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        MOV     DPTR,#ADPRIR    ;TEST CI JE 'KZ' PRIRADENE
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        CJNE    A,#55H,KNOPR    ;SKOK AK NIE JE PRIRADENE 'KZ'
        ANL     DPHR,#01H       ;V DPTR JE ADRESA LINKY 'KZ'
        MOV     B,POM1          ;ZISTI POCET OPAKOVANI 20ms(18 KHz) + 10 ms(PAUZA)
        ANL     B,#0FH          ;POCET JE V INTERVALE 1 az 8
        CALL    SETOBJ          ;NASTAV PODLA 'DPTR' SELEKCIU LINKY 'KZ'
KOLOKV: SETB    EN18            ;GENERUJ 18 KHz
        CALL    TIM5MS
        CALL    TIM5MS
        CALL    TIM5MS
        CALL    TIM5MS          ;CAKAJ 20 ms
        CLR     EN18            ;VYPNI 18 KHz
        CALL    TIM5MS
        CALL    TIM5MS          ;CAKAJ 10 ms
        DJNZ    B,KOLOKV
RETKVI: POP     B
        POP     ACC
        POP     PSW
        POP     DPHR
        POP     DPLR
        RET
KNOPR:  MOV     B,#KZERPO       ;PRIZNAK 'CHYBA PRIRADENIA/ODRADENIA KZ'
        CALL    PUTBUF
        LJMP    RETKVI
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
HDUPLX: PUSH    DPLR            ;VYSLANIE BYTU NA 'KZ'
        PUSH    DPHR
        PUSH    PSW             ;POTREBUJE 9 BYTOV ZASOBNIKA
        PUSH    ACC
        PUSH    B
        PUSH    POM1
        PUSH    POM2
        MOV     DPTR,#ADPRIR    ;TEST CI JE 'KZ' PRIRADENE
        ANL     DPHR,#0FEH
        MOV     DPLR,POM2
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        CJNE    A,#55H,HNOPR0   ;SKOK AK NIE JE PRIRADENE 'KZ'
        ANL     DPHR,#01H
        MOV     HDBYTE,POM1     ;UCHOVAJ VYSIELANY BYTE DO 'KZ'
        ANL     HDBYTE,#07FH
        CALL    SETOBJ          ;NASTAV LINKU 'KZ' PRE VYSLANIE BYTU Z 'ATS'
;       CALL    OBJEKT          ;PODPROGRAM OBSLUHY LINKY, CO AK MA 'KZ' SPRAVU ?
;===
        CLR     TBIT            ;NASTAV POMOCNY BIT PODLA STAVU 'R18'
        JNB     R18,R18NUL
        SETB    TBIT
R18NUL: MOV     POM1,#2         ;NASTAVI max. CAKANIE 10 ms NA ZMENU STAVU 'R18'
TWAI0:  MOV     INTTIM,#00H     ;NA R18 BY MALI BYT PULZY 4 ms !!!
TWAI1:  JNB     TBIT,NULA1
        JNB     R18,ZMENA
        LJMP    TWAI2
NULA1:  JB      R18,ZMENA
TWAI2:  MOV     A,#79           ;DOPLNOK K 5 ms x POM1 = 10 ms
        ADD     A,INTTIM
        JNC     TWAI1
        DJNZ    POM1,TWAI0      ;CAKA AK NEVYPRSAL CAS 10 ms
        MOV     B,#REZ1         ;NASTAV SPRAVU 'KZ NEPREVZALO POVEL'
        LJMP    ZMENA           ;!!! POVODNE : (LJMP    HPUT) - UPRAVA PROTOKOLU (100 ms)
HNOPR0: LJMP    HNOPR
;
ZMENA:  CALL    SEND18          ;PODPROGRAM VYSLANIA BYTU DO 'KZ'
        MOV     A,EROR18        ;55H = 'KZ' PREVZALO POVEL, (INAK) = 'KZ' NEPREVZALO POVEL
        MOV     B,#REZ1         ;NASTAV SPRAVU 'KZ' NEPREVZALO POVEL
        CJNE    A,#55H,HPUT     ;SKOK AK BOLA CHYBA VO VYSIELANI
        MOV     B,#REZ2         ;NASTAV SPRAVU 'KZ PREVZALO POVEL'
        CALL    PUTBUF
;TEST CI ISLO O POVEL 'RESET KZ' - AK ANO NULUJE KOMUNIKACIU 'High SECURITY' !!!
        POP     POM2            ;OBNOV PARAMETRE PRIJATEHO POVELU Z 'PC' PRE 'KZ'
        POP     POM1
        PUSH    POM1
        PUSH    POM2
        MOV     A,POM1          ;TEST CI BOL VYSIELANY POVEL NA 'RESET KZ'
        ANL     A,#07FH         ;MASKUJ NAJVYSSI BIT
        CJNE    A,#RESKZ,NRKZ
;
        MOV     DPTR,#ADSEC     ;NASTAV PARAMETRE TYPU 'KZ' PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        CLR     TBIT            ;NULUJ POMOCNY PRIZNAK
        MOVX    A,@DPTR
        CJNE    A,#55H,HNSPC    ;TEST CI IDE O STANDARTNY TYP 'KZ' ('CRC' POLYNOM)
        SETB    TBIT
HNSPC:  MOV     DPTR,#ADBIT     ;NASTAV VSETKY POVELY A POZIADAVKY PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        JB      TBIT,HOCLA1     ;!!!SKOK AK JE KLASICKY TYP ('CRC')
        MOV     A,#00H
        LJMP    HACLA1
HOCLA1: MOV     A,#03H          ;NASTAV POZIADAVKU 'CRC=80H' a '"KZ" - DAJ AKTUALNE CRC'
HACLA1: MOVX    @DPTR,A
        MOV     DPTR,#ADCRC     ;NASTAV POLYNOM PRE 'HIGH SECURITY'
        MOV     DPLR,POM2
        ANL     DPHR,#0FEH
        MOV     A,POM1
        RL      A
        ANL     A,#01H
        ORL     DPHR,A
        JB      TBIT,HOCLA2     ;!!!SKOK AK JE KLASICKY TYP ('CRC')
        MOV     A,#00H
        LJMP    HACLA2
HOCLA2: MOV     A,#80H          ;NASTAV POLYNOM 'CRC=80H'
HACLA2: MOVX    @DPTR,A
;
NRKZ:   LJMP    ZAPUT
;===
RETHDX: POP     POM2
        POP     POM1
        POP     B
        POP     ACC
        POP     PSW
        POP     DPHR
        POP     DPLR
        RET
HNOPR:  MOV     B,#KZERPO       ;PRIZNAK 'CHYBA PRIRADENIA/ODRADENIA KZ'
HPUT:   CALL    PUTBUF
ZAPUT:  LJMP    RETHDX
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HDBYTE-VYSIELANY BYTE, NA LINKE BOLA ZMENA (PULZY) PRED SPUSTENIM PODPROGRAMU
;EROR18-PRIZNAK CHYBNEHO VYSIELANIA (55H = OK !, INAK = CHYBA)
;
SEND18: MOV     EROR18,#55H     ;NASTAV PRIZNAK BEZCHYBNEHO VYSLANIA BYTU DO 'KZ'
        MOV     POM1,#20        ;NASTAV CAS CAKANIA 100 ms = 20 x 5 ms
        SETB    EN18            ;GENERUJ 100 ms 18 KHz
SKOLO1: CALL    TIM5MS
        DJNZ    POM1,SKOLO1
        CLR     EN18            ;VYPNI 18 KHz A CAKAJ 5 ms NA USTALENIE LINKY
        CALL    TIM5MS
;CAKANIE NA NADVIAZANIE SPOJENIA
        MOV     POM1,#200       ;CAKANIE 40 ms NA PRIJEM IMPULZU 10 ms Z 'KZ'
        MOV     POM2,#00H       ;MERANIE DLZKY PRIJATEHO IMPULZU (PRESNOST 0.2 ms)
SWAI0:  MOV     INTTIM,#00H
SWAI1:  JB      R18,NIE18K
SWAI3:  MOV     A,#249          ;7 x PRERUSENIE PRE 0.2 ms
        ADD     A,INTTIM
        JNC     SWAI1
        INC     POM2            ;POCITAJ DLZKU PRIJIMANEHO PULZU 18 KHz
        DJNZ    POM1,SWAI0
SEROR:  MOV     EROR18,#0AAH    ;NASTAV PRIZNAK CHYBNEHO VYSIELANIA BYTU DO 'KZ'
SHEND:  CLR     EN18            ;ZABLOKUJ GENERATOR 18 KHz
        RET
NIE18K: MOV     A,#226          ;PRE  6 ms MUSI NASTAT PRERUSENIE 30 x
        ADD     A,POM2
        JC      S8MS
S8MS0:  MOV     POM2,#00H       ;PRE IMPULZ < 6 ms UMOZNI CAKAT NA DALSI POKUS
        LJMP    SWAI3
S8MS:   MOV     A,#186          ;PRE 14 ms MUSI NASTAT PRERUSENIA 70 x
        ADD     A,POM2
        JC      S8MS0           ;PRIJATY IMPULZ MUSI BYT V INTERVALE <6,14> ms
;VYSLANIE 8 BITOV Z 'HDBYTE'
        MOV     POM1,#8         ;NASTAV POCET VYSIELANYCH BITOV
        CLR     EN18            ;ZABLOKUJ GENERATOR 18 KHz
SOPAK:  CALL    TIM4MS
        MOV     A,HDBYTE        ;ZISTI HODNOTU VYSIELANEHO BITU
        RRC     A
        MOV     HDBYTE,A
        SETB    EN18            ;ZAPNI GENERATOR 18 KHz
        JNC     SIMP4           ;0=4ms IMPULZ
        CALL    TIM4MS
SIMP4:  CALL    TIM4MS          ;1=8ms IMPULZ
        CLR     EN18            ;VYPNI GENERATOR 18 KHz
        DJNZ    POM1,SOPAK
        MOV     A,HDBYTE        ;VRAT POVODNU HODNOTU DO 'HDBYTE' PRE DALSIE SPRACOVANIE
        RRC     A
        MOV     HDBYTE,A
        CALL    TIM4MS          ;CAKAJ 4 ms - USTALENIE PRIEBEHOV
;PRIJEM POTVRDENIA PREVZATIA BYTU
        MOV     POM1,#250       ;CAKANIE 50 ms NA PRIJEM IMPULZU 20 ms Z 'KZ'
        MOV     POM2,#00H       ;MERANIE DLZKY PRIJATEHO IMPULZU (PRESNOST 0.2 ms)
SWAI4:  MOV     INTTIM,#00H
SWAI5:  JB      R18,NIE18
SWAI6:  MOV     A,#249          ;7 x PRERUSENIE PRE 0.2 ms
        ADD     A,INTTIM
        JNC     SWAI5
        INC     POM2            ;POCITAJ DLZKU PRIJIMANEHO PULZU 18 KHz
        DJNZ    POM1,SWAI4
        LJMP    SEROR
NIE18:  MOV     A,#176          ;PRE 16 ms MUSI NASTAT PRERUSENIE  80 x
        ADD     A,POM2
        JC      SWAI8
SWAI7:  MOV     POM2,#00H       ;PRE IMPULZ < 16 ms UMOZNI CAKAT NA DALSI POKUS
        LJMP    SWAI6
SWAI8:  MOV     A,#136          ;PRE 24 ms MUSI NASTAT PRERUSENIA 120 x
        ADD     A,POM2
        JC      SWAI7           ;PRIJATY IMPULZ MUSI BYT V INTERVALE <16,24> ms
;CAKANIE NA USTALENIE 'KZ' 'SW'
        CALL    TIM5MS          ;CAKA 20 ms NA VYSLANIE BYTU SERIOVOU LINKOU Z 'KZ'
        CALL    TIM5MS          ;RYCHLOSTOU cca. 1200 b/s
        CALL    TIM5MS
        CALL    TIM5MS
        MOV     EROR18,#55H     ;PRIZNAK SPRAVNEH PRENOSU BYTU DO 'KZ'
        LJMP    SHEND
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TIM1MS: PUSH    PSW             ;POTREBUJE 4 BYTY ZASOBNIKA
        PUSH    ACC
        MOV     INTTIM,#00H     ;CAKACIA SLUCKA 1 ms (34 x NASTANE PRERUSENIE)
W1MS:   MOV     A,#222          ;256-34=222 - TEST CI UPLYNUL POZADOVANY CAS
        ADD     A,INTTIM
        JNC     W1MS
        POP     ACC
        POP     PSW
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TIM4MS: PUSH    PSW             ;POTREBUJE 4 BYTY ZASOBNIKA
        PUSH    ACC
        MOV     INTTIM,#00H     ;CAKACIA SLUCKA 4 ms (143 x NASTANE PRERUSENIE)
W4MS:   MOV     A,#113          ;256-143=113 - TEST CI UPLYNUL POZADOVANY CAS
        ADD     A,INTTIM
        JNC     W4MS
        POP     ACC
        POP     PSW
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TIM5MS: PUSH    PSW             ;POTREBUJE 4 BYTY ZASOBNIKA
        PUSH    ACC
        MOV     INTTIM,#00H     ;CAKACIA SLUCKA 5 ms (177 x NASTANE PRERUSENIE)
W5MS:   MOV     A,#79           ;256-177=79 - TEST CI UPLYNUL POZADOVANY CAS
        ADD     A,INTTIM
        JNC     W5MS
        POP     ACC
        POP     PSW
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;CINNOST V TOMTO PODPROGRAME NESMIE TRVAT DLHSIE AKO <!!! 130 !!!> ms
;
OBJEKT: MOV     A,CYCLES        ;NASTAVUJE POCITADLO OBJEKTOVYCH KOMUNIKACII
        JZ      CYCL0
        DEC     CYCLES
CYCL0:  JNB     AKTOBJ,RUNOBJ   ;ZABLOKUJ 'REKURZIVNY' ALGORITMUS
        LJMP    AREOBJ          ;VYSKOC Z PODPROGRAMU
RUNOBJ: JB      NOINCR,RENOIN
        MOV     MAXREP,#REPMAX  ;NASTAV MAX. POCET OPAKOVANI ZA SEBOU JEDNEHO 'KZ' (32 BYTOV)
        MOV     POBJ3,#OBJMAX   ;MAX. (POBJ3) x OPAKUJE TEST DLZKY IMPULZu/MEDZERy
        MOV     MWORK1,#5       ;(10)POCET OPAKOVANI PRI CHYBNOM PRIJME BYTU Z 'KZ'
RENOIN: CLR     NOINCR          ;NULUJ POZIADAVKU NA NEADRESOVANIE DALSIEHO OBJEKTU
        SETB    AKTOBJ          ;PRIZNAK AKTIVNEHO PODPROGRAMU OBJEKT
        PUSH    DPLR            ;OBSLUZNY PODPROGRAM OBJEKTU - UCHOVA ADRESU 'KZ'
        PUSH    DPHR            ;AK 'AKTPRT'=1 - NESMIE UZ VOLAT 'CALL PROTOK' !!!
;TEST CI JE VYSIELACI BUFFER PLNY - AK ANO NETESTUJE 'KZ'
OKOLO:  CLR     FULTXL          ;NULUJ PRIZNAK PLNOSTI VYSIELACIEHO BUFFRA
        MOV     A,#MAXTXR       ;VELKOST BUFFRA < 147 BYTOV (146 MOZE BYT - 2 BYTY SU REZERVA)
        ADD     A,LONRET
        JNC     ONOFUL
        SETB    FULTXL          ;NASTAV PRIZNAK PLNOSTI VYSIELACIEHO BUFFRA
        LJMP    SETINC          ;NETESTUJ AK JE VYSIELACI BUFFER PLNY
;TEST CI SU 4 ms PULZY NA LINKE
ONOFUL: CLR     TBIT            ;NASTAV POMOCNY BIT PODLA STAVU 'R18'
        JNB     R18,OR18NU
        SETB    TBIT
OR18NU: MOV     POBJ1,#2        ;NASTAVI max. CAKANIE 10 ms NA ZMENU STAVU 'R18'
OTWAI0: MOV     INTTIM,#00H     ;NA R18 BY MALI BYT PULZY 4 ms !!!
OTWAI1: JNB     TBIT,ONULA1
        JNB     R18,OZMENA
        LJMP    OTWAI2
ONULA1: JB      R18,OZMENA
OTWAI2: MOV     A,#79           ;DOPLNOK K 5 ms x POBJ1 = 10 ms
        ADD     A,INTTIM
        JNC     OTWAI1
        DJNZ    POBJ1,OTWAI0    ;CAKA AK NEVYPRSAL CAS 10 ms
        LJMP    ONOZME          ;SKOK AK NIE JE ZMENA STAVU (STALE 18 KHz ALEBO NIC)
;TEST DLZKY PULZU/MEDZERY (MUSI BYT V <2.4,5.6> ms)
OZMENA: MOV     POBJ2,#50       ;TEST DLZKY TRVA max. 10 ms (50 x 0.2 ms)
        CLR     TBIT            ;NASTAV POMOCNY BIT PODLA STAVU 'R18'
        JNB     R18,OR18N
        SETB    TBIT
OR18N:  MOV     POBJ1,#0        ;NULUJ POCITADLO DLZKY IMPULZU/MEDZERY
OTWA0:  MOV     INTTIM,#00H     ;NA R18 BY MALI BYT PULZY 4 ms !!!
OTWA1:  JNB     TBIT,ONUL1
        JNB     R18,OZMEN1
        LJMP    OTWA2
ONUL1:  JB      R18,OZMEN1
OTWA2:  MOV     A,#249          ;DOPLNOK K 0.2 ms => 7 x NASTANE PRERUSENIE
        ADD     A,INTTIM
        JNC     OTWA1
        INC     POBJ1           ;POCITA DLZKU IMPULZU/MEDZERY
        DJNZ    POBJ2,OTWA0     ;TEST UPLYNUTIA max. DOBY TESTOVANIA
        LJMP    ONOZM1
OZMEN1: MOV     A,#244          ;PRERUSENIE 12 x 0.2 ms = 2.4 ms
        ADD     A,POBJ1
        JC      IS26MS          ;SKOK AK JE > AKO 2.4 ms (VIAC AKO 12 PRERUSENI)
NOLONG: LJMP    ONOZM1          ;OPAKUJ TEST NA SPOJENIE S OBJEKTOM (NIE <2.4,5.6>)
IS26MS: MOV     A,#228          ;PRERUSENIE 28 x 0.2 ms = 5.6 ms
        ADD     A,POBJ1
        JC      NOLONG          ;SKOK AK JE IMPULZ > 5.6 ms (VIAC AKO 28 PRERUSENI)
        MOV     POBJ1,DPLR      ;UCHOVANIE ADRESY OBJEKTU
        MOV     POBJ2,DPHR
        MOV     DPTR,#ADSTAT    ;TEST BITU STRATA SPOJENIA
        ANL     DPHR,#0FEH      ;MASKUJ NAJVYSSI BIT ADRSY 'KZ'
        MOV     DPLR,POBJ1
        MOV     A,POBJ2
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        CLR     TBIT            ;NULUJ POMOCNY BIT
        JNB     ACC.BSPOJ,BJEN  ;SKOK AK NEBOLA STRATA SPOJENIA
        SETB    TBIT
BJEN:   CLR     ACC.BSPOJ       ;NULUJ PRIZNAK 'STRATA SPOJENIA S KZ'
        CLR     ACC.BKZER       ;NULUJ PRIZNAK 'PORUCHA KZ'
        CLR     ACC.BNEZR       ;NULUJ PRIZNAK 'DATA NEZROZUMITELNE'
        MOVX    @DPTR,A
        JNB     TBIT,ONOPUT     ;SKOK AK NETREBA VYSLAT SPRAVU O OBNOVENI SPOJENIA
        MOV     B,#UNLOST
        CALL    PUTBUF          ;VLOZ SPRAVU DO VYSIELACIEHO BUFFRA
ONOPUT: MOVX    A,@DPTR         ;TEST CI JE POZIADAVKA NA 'DOTAZ KZ'
        JNB     ACC.BDOTAZ,ONOD
        CLR     ACC.BDOTAZ
        MOVX    @DPTR,A         ;NULUJ POZIADAVKU NA 'DOTAZ KZ'
        SETB    EN18            ;ZAPNI GENERATOR 18 KHz
        MOV     POBJ1,#12       ;12 x 5 ms = 60 ms IMPULZ DOTAZU
OGEND:  CALL    TIM5MS          ;CAKACI INTERVAL
        DJNZ    POBJ1,OGEND
        CLR     EN18            ;VYPNI GENERATOR 18 KHz
        CALL    TIM5MS          ;CAKA 20 ms NA USTALENIE STAVU LINKY A 'KZ'
        CALL    TIM5MS
        CALL    TIM5MS
        CALL    TIM5MS
;       LJMP    SETINC          ;OPAKUJ TEST OBJEKTU ('KZ' ODPOVEDA NA DOTAZ)
ONOD:   LJMP    RETOBJ          ;UKONCI TEST OBJEKTU (S 'DOTAZom' ZA max. cca. 100 ms)
;NA LINKE JE STALE 18 KHz ALEBO NIJAKY SIGNAL (STRATA SPOJENIA/'KZ' MA SPRAVU)
;PRVYCH 10 ms SA NA LINKE NIC NEZMENILO
ONOZME: JB      R18,ONO18       ;SKOK AK NA LINKE NIE JE 18 KHz
        MOV     POBJ1,DPLR      ;UCHOVAJ ADRESU OBJEKTU
        MOV     POBJ2,DPHR
        MOV     DPTR,#ADSTAT    ;TEST CI UZ JE AKTIVNY PRIZNAK 'PORUCHA KZ'
        ANL     DPHR,#0FEH      ;MASKUJ NAJVYSSI BIT ADRSY 'KZ'
        MOV     DPLR,POBJ1
        MOV     A,POBJ2
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        JNB     ACC.BKZER,ONOER ;SKOK AK NIE JE AKTIVNY PRIZNAK 'PORUCHA KZ'
        LJMP    RETOBJ
ONOER:  MOV     POBJ1,#25       ;POCITADLO 500 ms (AK 500 ms JE 18 KHz IDE O 'PORUCHU')
ONO00:  MOV     POBJ2,#100      ;25 x 100 x 0.2 ms = 500 ms (2 500 x PRERUSENIE)
ONO01:  MOV     INTTIM,#00H
ONO02:  MOV     A,#249          ;DOPLNOK PRE 0.2 ms (7 x PRERUSENIE)
        ADD     A,INTTIM
        JNC     ONO02
        JNB     RI,ONOSE1       ;TEST CI JE POZIADAVKA PROTOKOLU
        LJMP    SETINC          ;ZABLOKUJ ADRESOVANIE DALSIEHO OBJEKTU (OBSLUHA PROTOKOLU)
ONOSE1: JB      R18,OZME18      ;SKOK AK NETRVA 18 KHz ASPON 1 x 500 ms
        DJNZ    POBJ2,ONO01
        DJNZ    POBJ1,ONO00
        MOVX    A,@DPTR         ;NASTAV PRIZNAK 'PORUCHA KZ'
        SETB    ACC.BKZER       ;'BKZER' SA NULUJE LEN AK JE SPRAVNE SPOJENIE !!!
        MOVX    @DPTR,A
        MOV     B,#KZERR        ;VYSLI PRIZNAK 'PORUCHA KZ'
        CALL    PUTBUF
OZME18: LJMP    RETOBJ
ONO18:  MOV     MWORK2,#3       ;(4)POCET OPAK. IMPULZU VYZVY PRED SPRAVOU 'STRATA SPOJA'
STR:    SETB    EN18            ;GENERUJ 10 ms 18 KHz IMPULZ - VYZIADAJ BYTE Z 'KZ'
        CALL    TIM5MS
        CALL    TIM5MS
        CLR     EN18            ;VYPNI GENERATOR 18 KHz
        MOV     POBJ1,#50       ;(100)DO 10 ms ZANIKNE 18 KHz NA LINKE (ECHO MODEMU)
ONO03:  MOV     INTTIM,#00H
ONO04:  MOV     A,#249          ;DOPLNOK PRE 0.2 ms (7 x PRERUSENIE)
        ADD     A,INTTIM
        JNC     ONO04
        JB      R18,OZANIK      ;SKOK AK ZANIKLO ECHO 18 KHz
        DJNZ    POBJ1,ONO03
        LJMP    OBRYW           ;ECHO NEZANIKLO - INFORMACIA O SIGNALE 18 KHz NA LINKE
OZANIK: MOV     POBJ1,#100      ;CAKAJ 20 ms NA ODPOVED Z 'KZ' (100 x 0.2 ms)
ONO05:  MOV     INTTIM,#00H
ONO06:  MOV     A,#249          ;DOPLNOK PRE 0.2 ms (7 x PRERUSENIE)
        ADD     A,INTTIM
        JNC     ONO06
        JNB     R18,OODP18      ;SKOK AK PRISLA ZMENA DO 18 KHz DO 20 ms Z 'KZ'
        DJNZ    POBJ1,ONO05
OBRYW:  MOV     POBJ1,DPLR      ;UCHOVAJ ADRESU OBJEKTU
        MOV     A,DPHR
        ANL     A,#01H
        MOV     DPTR,#ADSTAT    ;ZISTI CI UZ JE PRIZNAK STRATY SPOJENIA S 'KZ'
        ANL     DPHR,#0FEH      ;MASKUJ NAJVYSSI BIT ADRESY
        MOV     DPLR,POBJ1
        ORL     DPHR,A
        MOVX    A,@DPTR
        JNB     ACC.BSPOJ,ONOLO ;SKOK AK NIE JE NASTAVENY PRIZNAK STRATY SPOJENIA
        JNB     ACC.BDOTAZ,ONDO
        CLR     ACC.BDOTAZ      ;ZRUS POZIADAVKU DOTAZU
RETOBR: MOVX    @DPTR,A
        MOV     B,#LOST         ;VYSLI SPRAVU 'STRATA SPOJENIA S KZ'
        CALL    PUTBUF
ONDO:   LJMP    RETOBJ
ONOLO:  DJNZ    MWORK2,STR      ;POKUS (MWORK) x NADVIAZAT SPOJENIE (max. 130 ms)
        SETB    ACC.BSPOJ       ;NASTAV PRIZNAK 'STRATA SPOJENIA S KZ'
;       MOVX    @DPTR,A
;       MOV     B,#LOST         ;VYSLI SPRAVU 'STRATA SPOJENIA S KZ'
;       CALL    PUTBUF
        LJMP    RETOBR          ;(RETOBJ)
OODP18: JNB     RI,ONOSE2       ;TEST CI JE POZIADAVKA PROTOKOLU
        LJMP    SETINC          ;ZABLOKUJ ADRESOVANIE DALSIEHO OBJEKTU
ONOSE2: CALL    KZBYTE          ;PRIJEM BYTU Z 'KZ'
        MOV     A,RXKZER        ;TEST CI JE PRIJATY BYTE 'OK'
        CJNE    A,#55H,ONOOK    ;55H = OK !, SKOK AK NIE JE 'OK' PRIJEM
        LJMP    HANDLE
ONOOK:  CALL    TIM5MS          ;CAKAJ 10 ms
        CALL    TIM5MS
        JNB     RI,ONOSE3       ;TEST CI JE POZIADAVKA PROTOKOLU
        LJMP    SETINC          ;ZABLOKUJ ADRESOVANIE DALSIEHO OBJEKTU
ONOSE3: DJNZ    MWORK1,STR      ;POKUS (MWORK1) x PRIJAT CHYBNU SPRAVU
SBOJNP: MOV     POBJ1,DPLR      ;UCHOVAJ ADRESU 'KZ'
        MOV     A,DPHR
        ANL     A,#01H
        MOV     DPTR,#ADSTAT
        ANL     DPHR,#0FEH      ;MASKUJ NAJVYSSI BIT ADRESY 'KZ'
        ORL     DPHR,A
        MOV     DPLR,POBJ1
        MOVX    A,@DPTR
        JNB     ACC.BNEZR,ONEZR ;TEST CI JE UZ NASTAVENY PRIZNAK 'DATA NEZROZUMITELNE'
        LJMP    RETOBJ
ONEZR:  SETB    ACC.BNEZR       ;NASTAV PRIZNAK 'DATA NEZROZUMITELNE'
        MOVX    @DPTR,A
        MOV     B,#NOVALI
        CALL    PUTBUF
        LJMP    RETOBJ
HANDLE: MOV     A,RXDATA        ;TEST CI PRIJATY BYTE MA NAJVYSSI BIT = 1 ('CRC')
        JB      ACC.7,OTH       ;VZDY POTVRDI PRIJEM BYTU AK IDE O 'CRC' KOMUNIKACIU
        CLR     FULTXH
        MOV     A,#MAXTX        ;JE VO VYSIELACOM BUFFRI MIESTO NA ZAPISANIE 1. SPRAVY ?
        ADD     A,LONRET
        JNC     OTH             ;AK JE MIESTO POTVRDI PRIJEM SPRAVY DO 'KZ'
        SETB    FULTXH          ;NASTAV PRIZNAK PLNOSTI VYSIELACIEHO BUFFRA
        LJMP    SETINC
OTH:    JNB     RI,ONOSE4       ;TEST CI JE POZIADAVKA PROTOKOLU
        LJMP    SETINC          ;ZABLOKUJ ADRESOVANIE DALSIEHO OBJEKTU
ONOSE4: CALL    TIM5MS          ;CAKA 5 ms PO PRIJME BYTU Z 'KZ'
        SETB    EN18            ;GENERUJ 18 KHz NA LINKU 'KZ' 40 ms - POTVRDENIE PRIJMU BYTU
        MOV     POBJ1,#8
ORO40:  CALL    TIM5MS
        DJNZ    POBJ1,ORO40
        CLR     EN18
        MOV     POBJ1,DPLR      ;UCHOVAJ ADRESU OBJEKTU - ZRUSENIE CHYB
        MOV     A,DPHR
        ANL     A,#01H
        MOV     DPTR,#ADSTAT    ;ZISTI CI UZ JE PRIZNAK STRATY SPOJENIA S 'KZ'
        ANL     DPHR,#0FEH      ;MASKUJ NAJVYSSI BIT ADRESY
        MOV     DPLR,POBJ1
        ORL     DPHR,A
        MOVX    A,@DPTR
        CLR     TBIT            ;NULUJ POMOCNY BIT
        JNB     ACC.BSPOJ,BJEN1 ;SKOK AK NEBOLA STRATA SPOJENIA
        SETB    TBIT
BJEN1:  CLR     ACC.BSPOJ       ;NULUJ PRIZNAK 'STRATA SPOJENIA S KZ'
        CLR     ACC.BKZER       ;NULUJ PRIZNAK 'PORUCHA KZ'
        CLR     ACC.BNEZR       ;NULUJ PRIZNAK 'DATA NEZROZUMITELNE'
        MOVX    @DPTR,A
        JNB     TBIT,ONOPT      ;SKOK AK NETREBA VYSLAT SPRAVU O OBNOVENI SPOJENIA
        MOV     B,#UNLOST
        CALL    PUTBUF          ;VLOZ SPRAVU DO VYSIELACIEHO BUFFRA
ONOPT:  CALL    TIM4MS          ;CAKA 4 ms NA USTALENIE STAVOV NA LINKE 'KZ'
        MOV     A,RXDATA        ;TEST CI NAJVYSSI BIT JE = 0 (POPLACHOVA SPRAVA !!!)
        JB      ACC.7,NONULA    ;VYNECHAVA PRIJATY 'CRC' POLYNOM
        MOV     B,RXDATA        ;ZAPIS DO VYSIELACIEHO BUFFRA PRIJATU SPRAVU
        CALL    PUTBUF
NOTSPC: MOV     A,MAXREP        ;TEST CI PRESIEL MAXIMALNY POCET OPAKOVANI PRIJMU Z JEDNEHO KZ
        JNZ     NEPRES
        LJMP    RETOBJ          ;V DALSOM KROKU ADRESUJE A TESTUJE INE 'KZ'
NEPRES: DEC     MAXREP          ;ZNIZ POCET TESTOVANI ROVNAKEHO 'KZ' V 'MAIN' SLUCKE PROGRAMU
        LJMP    SETINC          ;TEST NA DALSI PRIPADNY BYTE Z ROVNAKEHO 'KZ'
NONULA: MOV     ADCRCL,DPLR     ;UCHOVAJ ADRESU 'KZ' S KTOREHO PRIJAL BYTE
        MOV     ADCRCH,DPHR
        MOV     DPTR,#ADSEC
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;ZISTI CI IDE O TYP 'SPECIALNE KZ'
        CJNE    A,#55H,NOTSPC   ;AK NIE - IGNORUJE PRIJATY BYTE
        MOV     DPTR,#ADBIT
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;ZISTI NA AKU SPRAVU CAKA (ODPOVED NA 'DAJ CRC' / 'MODULOVANE CRC')
        JB      ACC.BWCRC,ISWG  ;CAKA ODPOVED NA 'DAJ CRC'
        JB      ACC.BMCRC,ISMC  ;CAKA MODULOVANE 'CRC'
        LJMP    NOTSPC          ;INAK IGNORUJ PRIJATY BYTE
ISWG:   CLR     ACC.BWCRC       ;NULUJ PRIZNAK CAKANIA PO PRIJATI BYTU Z 'KZ'
        MOVX    @DPTR,A
        MOV     DPTR,#ADCRC
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,RXDATA
        MOVX    @DPTR,A         ;ZAPIS PRIJATU HODNOTU 'CRC' DO PAMATE ('CRC' = HODNOTE V 'KZ')
        LJMP    NOTSPC
ISMC:   CLR     ACC.BMCRC       ;NULUJ PRIZNAK CAKANIA PO PRIJATI BYTU Z 'KZ'
        MOVX    @DPTR,A
        MOV     DPTR,#ADCRC
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;ZAPIS PRIJATU HODNOTU 'CRC' DO PAMATE
        XRL     A,RXDATA
        JNZ     CRCERR          ;BOL PRIJATY CHYBNY 'CRC' POLYNOM
        LJMP    NOTSPC
CRCERR: MOV     DPTR,#ADBIT     ;NASTAV PRIZNAK CHYBY PRI 'CRC' PROTOKOLE
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;ZAPIS CHYBU PRIJMU 'CRC' DO PAMATE
        SETB    ACC.BECRC
        MOVX    @DPTR,A
        LJMP    NOTSPC          ;VLOZ DO BUFFRA KOD 'PORUCHA KZ' ('DATA NEZROZUMITELNE')
;PULZ/MEDZERA TRVA DLHSIE AKO 10 ms (OPAKUJE POBJ3 x cca. 20 ms => min. cca 100 ms)
;? ZVAZIT CI NEVYSIELAT SPRAVU STRATA SPOJENIA S 'KZ' PO UKONCENI VSETKYCH TESTOV
ONOZM1: JNB     RI,ONOZ12       ;ZISTI CI MEDZI POZIADAVKOU NA TEST NIE JE AKTIVNY PROTOKOL
SETINC: SETB    NOINCR          ;POZIADAVKA NA PONECHANIE ADRESY OBJEKTU PRE TESTOVANIE
        LJMP    RETOBJ          ;VYSKOC Z OBSLUHY OBJEKTU (AK JE POZIADAVKA PROTOKOLU)
ONOZ12: DJNZ    POBJ3,OKOLO1    ;TEST CI TEST OPAKOVAL max. POVOLENY POCET KRAT
        LJMP    SBOJNP          ;SKOK NA 'STRATA SPOJENIA S KZ - UDAJE NEZROZUMITELNE'
OKOLO1: LJMP    OKOLO           ;POKRACUJ, PRIPADNE UKONCI PROTOKOL S 'KZ'
;
RETOBJ: POP     DPHR
        POP     DPLR
        CLR     AKTOBJ          ;NEAKTIVNY PODPROGRAM 'OBJEKT'
AREOBJ: RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;RXDATA - PRIJATY BYTE, RXKZER - PRIZNAK SPRAVNEHO PRIJMU (55H = OK)
;
KZBYTE: MOV     RXKZER,#55H     ;PRIJEM BYTU Z 'KZ' - PRIZNAK SPRAVNEHO PRIJMU
        MOV     RXDATA,#00H
        MOV     POBJ2,#8        ;POCET PRIJIMANYCH BITOV
BITKOL: MOV     POBJ1,#50       ;TEST NA DLZKU IMPULZU max. 10 ms (50 x 0.2 ms)
        MOV     TIMRX,#00       ;NULUJ POCITADLO CASU IMPULZ
KZ00:   MOV     INTTIM,#00H
KZ01:   MOV     A,#249          ;7 x PRERUSENIE PRE 0.2 ms
        ADD     A,INTTIM
        JNC     KZ01
        INC     TIMRX
        JB      R18,KZ02        ;CAKA DO SKONCENIA IMPULZU 18 KHz
        DJNZ    POBJ1,KZ00
RETER:  MOV     RXKZER,#0AAH    ;NASTAV PRIZNAK CHYBNEHO PRIJMU BYTU Z 'KZ'
        RET
KZ02:   CLR     TBIT            ;TEST HODNOTY PRIJATEHO PULZU + TEST DLZKY
        MOV     A,#244          ;TEST NA CAS > 2.4 ms
        ADD     A,TIMRX
        JNC     RETER
        MOV     A,#228          ;TEST NA CAS < 5.6 ms
        ADD     A,TIMRX
        JNC     ISBIT           ;SKOK AK IDE O HODNOTU BITU '0'
        MOV     A,#226          ;TEST NA CAS > 6 ms
        ADD     A,TIMRX
        JNC     RETER           ;SKOK NA CHYBU PRI INTERVALE <5.6,6> ms
        MOV     A,#206          ;TEST NA CAS < 10 ms
        ADD     A,TIMRX
        JC      RETER           ;SKOK NA CHYBU AK JE CAS IMPULZU > 10 ms
        SETB    TBIT            ;IDE O HODNOTU BITU '1'
ISBIT:  CLR     C               ;NASTAV PRIJATY BIT DO 'RXDATA'
        JNB     TBIT,IBITS
        SETB    C
IBITS:  MOV     A,RXDATA
        RRC     A
        MOV     RXDATA,A
        DJNZ    POBJ2,NOALLB    ;TEST CI JE PRIJATY CELY BYTE
        MOV     RXKZER,#55H     ;NASTAV PRIZNAK SPRAVNEHO PRIJMU BYTU Z 'KZ'
        RET
NOALLB: MOV     POBJ1,#50       ;TEST NA DLZKU IMPULZU max. 10 ms (50 x 0.2 ms)
        MOV     TIMRX,#00       ;NULUJ POCITADLO CASU PAUZA
KZ03:   MOV     INTTIM,#00H
KZ04:   MOV     A,#249          ;7 x PRERUSENIE PRE 0.2 ms
        ADD     A,INTTIM
        JNC     KZ04
        INC     TIMRX
        JNB     R18,KZ05        ;CAKA NA ZACIATOK IMPULZU 18 KHz
        DJNZ    POBJ1,KZ03
KZ05:   MOV     A,#241          ;TEST NA CAS > 3 ms (PAUZA <3,8> ms)
        ADD     A,TIMRX
        JNC     RETER
        MOV     A,#216          ;TEST NA CAS < 8 ms
        ADD     A,TIMRX
        JC      RETER
        LJMP    BITKOL          ;SKOK NA PRIJEM DALSIEHO BITU (PULZU 18 KHz)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PODPROGRAM OBSLUHY PROTOKOLU 'HIGH SECURITY'
;
;ADCRCH,ADCRCL PAMATA POSLEDNE REALIZOVANE 'KZ' V 'CRC' REZIME
;
SECUR:  PUSH    DPLR
        PUSH    DPHR
        CLR     ISCRC           ;NULUJ POZIADAVKU NA 'HIGH SECURITY' PROTOKOL
        ANL     POMH,#01H       ;DEFINOVANIE MAXIMALNE 512 'KZ'
        MOV     DPLR,POML       ;ZISTI ADRESU SPRACOVAVANEHO 'KZ'
        MOV     DPHR,POMH
SECTST: MOVX    A,@DPTR         ;TEST CI JE 'KZ' PRIRADENE
        CJNE    A,#55H,GETINY
        ANL     DPHR,#01H
        MOV     ADCRCL,DPLR
        MOV     ADCRCH,DPHR     ;UCHOVAJ NAJDENU ADRESU 'KZ'
        MOV     DPTR,#ADSEC     ;TEST CI IDE O TYP 'HIGH SECURITY'
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ORL     DPHR,A
        MOVX    A,@DPTR
        CJNE    A,#55H,GETINY
        LJMP    PRACUJ
GETINY: MOV     ERCRC,#00H      ;NULUJ POCET CHYBNYCH PRIJMOV V PROTOKOLE 'CRC'
        INC     DPTR
        ANL     DPHR,#01H       ;OBMEDZI MAX. POCET 'KZ' NA 512
        MOV     A,DPLR          ;TEST CI HLADAL MEDZI VEATKYMI CISLAMI
        XRL     A,POML
        JNZ     SECTST
        MOV     A,DPHR
        XRL     A,POMH
        JNZ     SECTST
        LJMP    NOTINY
SETINY: INC     DPTR            ;NASTAV ADRESU DALSIEHO TESTOVANEHO 'KZ'
        MOV     ERCRC,#00H      ;NULUJ POCET CHYBNYCH PRIJMOV V PROTOKOLE 'CRC'
NOTINY: ANL     DPHR,#01H       ;DEFINOVANIE MAX. 512 'KZ'
        MOV     POML,DPLR
        MOV     POMH,DPHR
        POP     DPHR
        POP     DPLR
        RET
PRACUJ: JNB     RI,CRCWRK
        SETB    ISCRC           ;NASTAV POZIADAVKU NA 'HIGH SEC.' PROT. PO OBSLUHE MUXu
        LJMP    NOTINY
;
CRCWRK: MOV     DPTR,#ADSTAT
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR         ;TEST CI JE NULOVY STAV. REG. (SPOJ,DOTAZ,ERROR,NEZROZ)
        ANL     A,#0F0H         ;TEST LEN HORE MENOVANYCH PRIZNAKOV
        CJNE    A,#00H,NEWGET
        MOV     DPTR,#ADBIT     ;TEST POZIADAVIEK A POVELOV NA PRACU S 'CRC'
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        JB      ACC.BECRC,NEWGET;SKOK AK NEBOLA ESTE VYSLANA SPRAVA 'PORUCHA KZ'
        JNB     ACC.BRCRC,RENO  ;SKOK AK NIE JE POZIADAVKA NASTAVIT 'CRC' = 80H
        CALL    SETOBJ          ;NASTAV OSETROVANU (TESTOVANU) LINKU 'KZ'
        MOV     HDBYTE,#RCRC    ;VYSLI POVEL NA NASTAVENIE 'CRC' = 80H
        CALL    SEND18
        MOV     A,EROR18        ;TEST CI VYSIELANIE PREBEHLO SPRAVNE
        CJNE    A,#55H,ERRCRC
        MOVX    A,@DPTR         ;NULUJ POZIADAVKU NA NASTAVENIE 'CRC' = 80H
        CLR     ACC.BRCRC
        CLR     ACC.BMCRC       ;NULUJ POZIADAVKU CAKANIA NA PREDOSLY POVEL 'MODULUJ CRC'
        CLR     ACC.BWCRC       ;NULUJ POZIADAVKU CAKANIA NA 'DAJ CRC' PREDOSLY POVEL
        CLR     ACC.BECRC       ;NULUJ PRIZNAK CHYBY PRIJMU 'CRC'
        CLR     ACC.BPOC1       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        CLR     ACC.BPOC2       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        SETB    ACC.BGCRC       ;NASTAV POZIADAVKU NA GENEROVANIE DOTAZU NA STAV 'CRC'
        SETB    ACC.BSPEC       ;NASTAV POZIADAVKU NA VYNECHANIE JEDNEHO CYKLU 'CRC'
        MOVX    @DPTR,A
        MOV     CYCLES,#SYNCYC  ;NASTAV MIN. POZADOVANY POCET TESTOV 'KZ' MEDZI 2-mi 'CRC'
        MOV     DPTR,#ADCRC     ;NULOVANIE 'CRC' POLYNOMU - POCIATIOCNA HODNOTA
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOV     A,#80H
EMPT:   MOVX    @DPTR,A
NEMPT:  ANL     DPHR,#01H       ;OBMEDZENIE NA MAX. 512 'KZ'
        MOV     ERCRC,#00H      ;NULUJ POCITADLO CHYBNYCH PRENOSOV
        LJMP    NOTINY
OKNIS:  ANL     DPHR,#01H
        LJMP    SETINY          ;NASTAV ADRESU DALSIEHO TESTOVANEHO 'KZ'
NEWGET: ANL     DPHR,#01H       ;SKUSI 'CRC' KOMUNIKACIU S INYM PRIRADENYM 'KZ'
        LJMP    GETINY
ERRCRC: MOV     A,#PCHYB
        ADD     A,ERCRC
        JC      NEZVYS
        INC     ERCRC
        LJMP    NOTINY          ;PREJDE VSETKY 'KZ' A OPAT SKUSI PROTOKOL
NEZVYS: SETB    ACC.BECRC       ;CHYBNE VYSLANIE BYTU DO 'KZ', NASTAV PRIZNAK CHYBY
        MOVX    @DPTR,A
        LJMP    OKNIS           ;SKOK NA TEST DALSIEHO 'KZ'
RENO:   JNB     ACC.BGCRC,GENO  ;SKOK AK NIE JE POZIADAVKA NA ZISTENIE REALNEHO 'CRC'
        JNB     ACC.BSPEC,NOSPE
        CLR     ACC.BSPEC
        LJMP    EMPT
NOSPE:  CALL    SETOBJ          ;NASTAV OSETROVANU (TESTOVANU) LINKU 'KZ'
        MOV     HDBYTE,#GCRC    ;VYSLI POVEL NA ZISTENIE HODNOTY 'CRC'
        CALL    SEND18
        MOV     A,EROR18        ;TEST CI VYSIELANIE PREBEHLO SPRAVNE
        CJNE    A,#55H,ERRCRC
        MOVX    A,@DPTR         ;NULUJ POZIADAVKU NA NASTAVENIE 'CRC' = 80H
        CLR     ACC.BGCRC
        CLR     ACC.BECRC       ;NULUJ PRIZNAK CHYBY PRIJMU 'CRC'
        CLR     ACC.BPOC1       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        CLR     ACC.BPOC2       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        CLR     ACC.BMCRC       ;NULUJ PRIZNAK CAKANIA NA MODULOVANY 'CRC'
        SETB    ACC.BWCRC       ;NASTAV PRIZNAK POZIADAVKY CAKANIA NA AKTUALNY OBSAH 'CRC'
        CLR     ACC.BSPEC       ;NULUJ POZIADAVKU NA VYNECHANIE CYKLU
        MOVX    @DPTR,A
        MOV     CYCLES,#SYNCYC  ;NASTAV MIN. POZADOVANY POCET TESTOV 'KZ' MEDZI 2-mi 'CRC'
        LJMP    NEMPT
GENO:   JNB     ACC.BWCRC,MM1   ;TEST CI MOZEM MODULOVAT 'CRC' V 'KZ' (NIC NECAKAM)
        LJMP    NMOZE           ;SKOK AK CAKAM ODPOVED NA PREDOSLU VYZVU
MM1:    JNB     ACC.BMCRC,MM2
NMOZE:  LJMP    NEWGET
MM2:    CALL    SETOBJ          ;NASTAV OSETROVANU (TESTOVANU) LINKU 'KZ'
        ORL     GENCRC,#80H     ;NASTAV NAJVYSSI BIT VYSIELANEJ SPRAVY = 1 (PRACA S 'CRC')
        MOV     HDBYTE,GENCRC   ;VYSLI POVEL NA MODULOVANIE HODNOTY 'CRC' V 'KZ'
        CALL    SEND18
        MOV     A,EROR18        ;TEST CI VYSIELANIE PREBEHLO SPRAVNE
        CJNE    A,#55H,ERRCRC
        MOVX    A,@DPTR         ;NULUJ POZIADAVKU NA NASTAVENIE 'CRC' = 80H
        CLR     ACC.BECRC       ;NULUJ PRIZNAK CHYBY PRIJMU 'CRC'
        CLR     ACC.BPOC1       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        CLR     ACC.BPOC2       ;NULUJ BIT POCITADLA CYKLOV CAKANIA NA ODPOVED
        SETB    ACC.BMCRC       ;NASTAV PRIZNAK CAKANIA NA MODULOVANY 'CRC'
        CLR     ACC.BWCRC       ;NULUJ PRIZNAK POZIADAVKY CAKANIA NA AKTUALNY OBSAH 'CRC'
        CLR     ACC.BSPEC       ;NULUJ POZIADAVKU NA VYNECHANIE CYKLU
        MOVX    @DPTR,A
        MOV     CYCLES,#MAXCYC  ;NASTAV MIN. POZADOVANY POCET TESTV 'KZ' MEDZI 2-mi 'CRC'
;VYPOCITAJ HODNOTU NOVEHO OCAKAVANEHO 'CRC' Z 'KZ'
;'CRC' - START
        MOV     DPTR,#ADCRC     ;TEST POZIADAVIEK A POVELOV NA PRACU S 'CRC'
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        MOV     B,A
;
;       Put CRC generator here !
;
        MOV     B,A             ;UCHOVAJ VYPOCITANE 'CRC'
        MOVX    @DPTR,A
;'CRC' - END
        MOV     A,#00H          ;ZMEN HODNOTU NAHODNEHO GENERATORA (AJ S POMOCOU 'STACKu')
        MOV     R0,#3FH
ZMENA1: XRL     A,@R0
        DJNZ    R0,ZMENA1
        ADD     A,GENCRC
        XRL     GENCRC,A
        ORL     GENCRC,#80H
        LJMP    OKNIS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;VYHODNOTENIE KOMUNIKACIE 'CRC' POLYNOMU PRE JEDNOTLIVE 'KZ' V SLUCKE
;
CRCMSG: PUSH    DPLR
        PUSH    DPHR
        ANL     DPHR,#01H
        MOVX    A,@DPTR         ;TEST CI ADRESOVANE 'KZ' JE PRIRADENE
        CJNE    A,#55H,PRINOT
        MOV     ADCRCL,DPLR
        MOV     ADCRCH,DPHR
        MOV     DPTR,#ADBIT     ;TEST NA POZIADAVKU GENEROVANIA SPRAVY 'CHYBA CRC'
        ANL     DPHR,#0FEH
        MOV     DPLR,ADCRCL
        MOV     A,ADCRCH
        ANL     A,#01H
        ORL     DPHR,A
        MOVX    A,@DPTR
        JNB     ACC.BECRC,NOERC ;SKOK AK NIE JE POZIADAVKA VYSLANIA SPRAVY NA CHYBU
CRC0:   CLR     FULTXH          ;TEST PLNOSTI VYSIELACIEHO BUFFRA
        MOV     A,#MAXTX        ;JE VO VYSIELACOM BUFFRI MIESTO NA ZAPISANIE 1. SPRAVY ?
        ADD     A,LONRET
        JNC     PRINO1          ;AK NIE JE MIESTO CAKA NA UVOLNENIE BUFFRA
        SETB    FULTXH          ;NASTAV PRIZNAK PLNOSTI BUFFRA
        LJMP    PRINOT
PRINO1: MOV     B,#CHYCRC       ;VYSLE KOD CHYBY KOMUNIKACIE 'CRC'
        CALL    PUTBUF
        MOV     A,#03H          ;START SYNCHRONIZACIE 'KZ' S PROTOKOLOM 'CRC' !!!
        MOVX    @DPTR,A         ;NULUJ POZIADAVKU NA VYSLANIE CHYBY + START SYNCHRONIZACIE
PRINOT: POP     DPHR
        POP     DPLR
        RET
NOERC:  JB      ACC.BWCRC,WKZC  ;SKOK AK CAKA NA PRIJEM BYTU 'CRC' Z 'KZ'
        JB      ACC.BMCRC,WKZC
        LJMP    PRINOT
WKZC:   JB      ACC.BPOC1,FULC1 ;TEST CI JE NAPLNENY CAS CAKANIA NA 'CRC' Z 'KZ'
FULC0:  ANL     A,#0CH          ;PRIPOCITAJ DOBU CYKLU CAKANIA
        ADD     A,#04H          ;PRIPOCITAJ POCET CYKLOV (CYKLUS = TEST VSETKYCH 512 KZ)
        ANL     A,#0CH
        MOV     B,A
        MOVX    A,@DPTR
        ANL     A,#0F3H         ;MASKUJ BITI POC1,POC2
        ORL     A,B
        MOVX    @DPTR,A
        LJMP    PRINOT
FULC1:  JNB     ACC.BPOC2,FULC0
        SETB    ACC.BECRC       ;NASTAV PRIZNAK VYSLANIA CHYBY PROTOKOLU 'CRC'
        MOVX    @DPTR,A
        LJMP    CRC0
;
;===================================================
;ZACIATOK HLAVNEHO PROGRAMU
;
RESTA:  LJMP    TESTS           ;SKOK NA INICIALIZACNE TESTY uP A INTERNEJ 'RWM'
INICI:  LJMP    INIC            ;SKOK NA INICIALIZACIU PARAMETROV SW A HW
KOLO:   LJMP    MAIN            ;SKOK NA NEKONECNU SLUCKU PROGRAMU
;
;KONIEC HLAVNEHO PROGRAMU
;===================================================
;
DATROM: DW      00EDBH          ;VYSLEDOK KONTROLNEJ SUMY CELEJ ROM
;
        ORG     0FB0H
        DB      '################'
        DB      '# END  atu0000 #'
        DB      '################'
;
        END
;